"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore

bytes = str


class QAbstractProxyModel(PySide2.QtCore.QAbstractItemModel):
    """
    **Detailed Description**

    This class defines the standard interface that proxy models must use to be able to interoperate correctly with other model/view components. It is not supposed to be instantiated directly.

    All standard proxy models are derived from the QAbstractProxyModel class. If you need to create a new proxy model class, it is usually better to subclass an existing class that provides the closest behavior to the one you want to provide.

    Proxy models that filter or sort items of data from a source model should be created by using or subclassing **QSortFilterProxyModel** .

    To subclass QAbstractProxyModel, you need to implement **mapFromSource** () and **mapToSource** (). The **mapSelectionFromSource** () and **mapSelectionToSource** () functions only need to be reimplemented if you need a behavior different from the default behavior.

    **Note:** If the source model is deleted or no source model is specified, the proxy model operates on a empty placeholder model.

    **See also** **QSortFilterProxyModel** , **QAbstractItemModel** , and **Model/View Programming** .
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        **QAbstractProxyModel::QAbstractProxyModel(QObject * parent = nullptr)**

        Constructs a proxy model with the given **parent**.
        """
        ...

    def buddy(self, index: PySide2.QtCore.QModelIndex) -> PySide2.QtCore.QModelIndex:
        """
        **[override virtual] QModelIndex QAbstractProxyModel::buddy(const QModelIndex & index ) const**

        Reimplements: **QAbstractItemModel::buddy** (const QModelIndex &index) const.
        """
        ...

    def canDropMimeData(
        self,
        data: PySide2.QtCore.QMimeData,
        action: PySide2.QtCore.Qt.DropAction,
        row: int,
        column: int,
        parent: PySide2.QtCore.QModelIndex,
    ) -> bool:
        """
        **[override virtual] bool QAbstractProxyModel::canDropMimeData(const QMimeData * data , Qt::DropAction action , int row , int column , const QModelIndex & parent ) const**

        Reimplements: **QAbstractItemModel::canDropMimeData** (const QMimeData *data, Qt::DropAction action, int row, int column, const QModelIndex &parent) const.

        This function was introduced in Qt 5.4.
        """
        ...

    def canFetchMore(self, parent: PySide2.QtCore.QModelIndex) -> bool:
        """
        **[override virtual] bool QAbstractProxyModel::canFetchMore(const QModelIndex & parent ) const**

        Reimplements: **QAbstractItemModel::canFetchMore** (const QModelIndex &parent) const.
        """
        ...

    def data(
        self, proxyIndex: PySide2.QtCore.QModelIndex, role: int = ...
    ) -> typing.Any:
        """
        **[override virtual] QVariant QAbstractProxyModel::data(const QModelIndex & proxyIndex , int role = Qt::DisplayRole) const**

        Reimplements: **QAbstractItemModel::data** (const QModelIndex &index, int role) const.

        **See also** **setData** ().
        """
        ...

    def dropMimeData(
        self,
        data: PySide2.QtCore.QMimeData,
        action: PySide2.QtCore.Qt.DropAction,
        row: int,
        column: int,
        parent: PySide2.QtCore.QModelIndex,
    ) -> bool:
        """
        **[override virtual] bool QAbstractProxyModel::dropMimeData(const QMimeData * data , Qt::DropAction action , int row , int column , const QModelIndex & parent )**

        Reimplements: **QAbstractItemModel::dropMimeData** (const QMimeData *data, Qt::DropAction action, int row, int column, const QModelIndex &parent).

        This function was introduced in Qt 5.4.
        """
        ...

    def fetchMore(self, parent: PySide2.QtCore.QModelIndex) -> None:
        """
        **[override virtual] void QAbstractProxyModel::fetchMore(const QModelIndex & parent )**

        Reimplements: **QAbstractItemModel::fetchMore** (const QModelIndex &parent).
        """
        ...

    def flags(self, index: PySide2.QtCore.QModelIndex) -> PySide2.QtCore.Qt.ItemFlags:
        """
        **[override virtual] Qt::ItemFlags QAbstractProxyModel::flags(const QModelIndex & index ) const**

        Reimplements: **QAbstractItemModel::flags** (const QModelIndex &index) const.
        """
        ...

    def hasChildren(self, parent: PySide2.QtCore.QModelIndex = ...) -> bool:
        """
        **[override virtual] bool QAbstractProxyModel::hasChildren(const QModelIndex & parent = QModelIndex()) const**

        Reimplements: **QAbstractItemModel::hasChildren** (const QModelIndex &parent) const.
        """
        ...

    def headerData(
        self, section: int, orientation: PySide2.QtCore.Qt.Orientation, role: int = ...
    ) -> typing.Any:
        """
        **[override virtual] QVariant QAbstractProxyModel::headerData(int section , Qt::Orientation orientation , int role = Qt::DisplayRole) const**

        Reimplements: **QAbstractItemModel::headerData** (int section, Qt::Orientation orientation, int role) const.

        **See also** **setHeaderData** ().
        """
        ...

    def itemData(self, index: PySide2.QtCore.QModelIndex) -> typing.Dict:
        """
        **[override virtual] QMap<int, QVariant> QAbstractProxyModel::itemData(const QModelIndex & proxyIndex ) const**

        Reimplements: **QAbstractItemModel::itemData** (const QModelIndex &index) const.

        **See also** **setItemData** ().
        """
        ...

    def mapFromSource(
        self, sourceIndex: PySide2.QtCore.QModelIndex
    ) -> PySide2.QtCore.QModelIndex:
        """
        **[pure virtual] QModelIndex QAbstractProxyModel::mapFromSource(const QModelIndex & sourceIndex ) const**

        Reimplement this function to return the model index in the proxy model that corresponds to the **sourceIndex** from the source model.

        **Note:** This function can be invoked via the meta-object system and from QML. See **Q_INVOKABLE** .

        **See also** **mapToSource** ().
        """
        ...

    def mapSelectionFromSource(
        self, selection: PySide2.QtCore.QItemSelection
    ) -> PySide2.QtCore.QItemSelection:
        """
        **[virtual] QItemSelection QAbstractProxyModel::mapSelectionFromSource(const QItemSelection & sourceSelection ) const**

        Returns a proxy selection mapped from the specified **sourceSelection**.

        Reimplement this method to map source selections to proxy selections.

        **Note:** This function can be invoked via the meta-object system and from QML. See **Q_INVOKABLE** .
        """
        ...

    def mapSelectionToSource(
        self, selection: PySide2.QtCore.QItemSelection
    ) -> PySide2.QtCore.QItemSelection:
        """
        **[virtual] QItemSelection QAbstractProxyModel::mapSelectionToSource(const QItemSelection & proxySelection ) const**

        Returns a source selection mapped from the specified **proxySelection**.

        Reimplement this method to map proxy selections to source selections.

        **Note:** This function can be invoked via the meta-object system and from QML. See **Q_INVOKABLE** .
        """
        ...

    def mapToSource(
        self, proxyIndex: PySide2.QtCore.QModelIndex
    ) -> PySide2.QtCore.QModelIndex:
        """
        **[pure virtual] QModelIndex QAbstractProxyModel::mapToSource(const QModelIndex & proxyIndex ) const**

        Reimplement this function to return the model index in the source model that corresponds to the **proxyIndex** in the proxy model.

        **Note:** This function can be invoked via the meta-object system and from QML. See **Q_INVOKABLE** .

        **See also** **mapFromSource** ().
        """
        ...

    def mimeData(self, indexes: typing.List) -> PySide2.QtCore.QMimeData:
        """
        **[override virtual] QMimeData *QAbstractProxyModel::mimeData(const QModelIndexList & indexes ) const**

        Reimplements: **QAbstractItemModel::mimeData** (const QModelIndexList &indexes) const.
        """
        ...

    def mimeTypes(self) -> typing.List:
        """
        **[override virtual] QStringList QAbstractProxyModel::mimeTypes() const**

        Reimplements: **QAbstractItemModel::mimeTypes** () const.
        """
        ...

    def resetInternalData(self) -> None:
        """
        **[protected slot] void QAbstractProxyModel::resetInternalData()**

        Clears the **roleNames**  of this proxy model.
        """
        ...

    def revert(self) -> None:
        """
        **[override virtual] void QAbstractProxyModel::revert()**

        Reimplements: **QAbstractItemModel::revert** ().
        """
        ...

    def setData(
        self, index: PySide2.QtCore.QModelIndex, value: typing.Any, role: int = ...
    ) -> bool:
        """
        **[override virtual] bool QAbstractProxyModel::setData(const QModelIndex & index , const QVariant & value , int role = Qt::EditRole)**

        Reimplements: **QAbstractItemModel::setData** (const QModelIndex &index, const QVariant &value, int role).

        **See also** **data** ().
        """
        ...

    def setHeaderData(
        self,
        section: int,
        orientation: PySide2.QtCore.Qt.Orientation,
        value: typing.Any,
        role: int = ...,
    ) -> bool:
        """
        **[override virtual] bool QAbstractProxyModel::setHeaderData(int section , Qt::Orientation orientation , const QVariant & value , int role = Qt::EditRole)**

        Reimplements: **QAbstractItemModel::setHeaderData** (int section, Qt::Orientation orientation, const QVariant &value, int role).

        **See also** **headerData** ().
        """
        ...

    def setItemData(
        self, index: PySide2.QtCore.QModelIndex, roles: typing.Dict
    ) -> bool:
        """
        **[override virtual] bool QAbstractProxyModel::setItemData(const QModelIndex & index , const QMap<int, QVariant> & roles )**

        Reimplements: **QAbstractItemModel::setItemData** (const QModelIndex &index, const QMap<int, QVariant> &roles).

        **See also** **itemData** ().
        """
        ...

    def setSourceModel(self, sourceModel: PySide2.QtCore.QAbstractItemModel) -> None:
        """
        **[virtual] void QAbstractProxyModel::setSourceModel(QAbstractItemModel * sourceModel )**

        Sets the given **sourceModel** to be processed by the proxy model.

        Subclasses should call **beginResetModel** () at the beginning of the method, disconnect from the old model, call this method, connect to the new model, and call **endResetModel** ().

        **Note:** Setter function for property **sourceModel** .

        **See also** **sourceModel** ().
        """
        ...

    def sibling(
        self, row: int, column: int, idx: PySide2.QtCore.QModelIndex
    ) -> PySide2.QtCore.QModelIndex:
        """
        **[override virtual] QModelIndex QAbstractProxyModel::sibling(int row , int column , const QModelIndex & idx ) const**

        Reimplements: **QAbstractItemModel::sibling** (int row, int column, const QModelIndex &index) const.
        """
        ...

    def sort(self, column: int, order: PySide2.QtCore.Qt.SortOrder = ...) -> None:
        """
        **[override virtual] void QAbstractProxyModel::sort(int column , Qt::SortOrder order = Qt::AscendingOrder)**

        Reimplements: **QAbstractItemModel::sort** (int column, Qt::SortOrder order).
        """
        ...

    def sourceModel(self) -> PySide2.QtCore.QAbstractItemModel:
        """
        **QAbstractItemModel *QAbstractProxyModel::sourceModel() const**

        Returns the model that contains the data that is available through the proxy model.

        **Note:** Getter function for property sourceModel.

        **See also** **setSourceModel** ().
        """
        ...

    def span(self, index: PySide2.QtCore.QModelIndex) -> PySide2.QtCore.QSize:
        """
        **[override virtual] QSize QAbstractProxyModel::span(const QModelIndex & index ) const**

        Reimplements: **QAbstractItemModel::span** (const QModelIndex &index) const.
        """
        ...

    def submit(self) -> bool:
        """
        **[override virtual] bool QAbstractProxyModel::submit()**

        Reimplements: **QAbstractItemModel::submit** ().
        """
        ...

    def supportedDragActions(self) -> PySide2.QtCore.Qt.DropActions:
        """
        **[override virtual] Qt::DropActions QAbstractProxyModel::supportedDragActions() const**

        Reimplements: **QAbstractItemModel::supportedDragActions** () const.
        """
        ...

    def supportedDropActions(self) -> PySide2.QtCore.Qt.DropActions:
        """
        **[override virtual] Qt::DropActions QAbstractProxyModel::supportedDropActions() const**

        Reimplements: **QAbstractItemModel::supportedDropActions** () const.
        """
        ...

    @property
    def sourceModelChanged(self) -> PySide2.QtCore.SignalInstance:
        ...
