"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui

bytes = str


class QAccessibleTextInsertEvent(PySide2.QtGui.QAccessibleTextCursorEvent):
    """
    **Detailed Description**

    This class is used with **QAccessible::updateAccessibility** ().
    """

    @typing.overload
    def __init__(
        self, iface: PySide2.QtGui.QAccessibleInterface, position: int, text: str
    ) -> None:
        """
        **QAccessibleTextInsertEvent::QAccessibleTextInsertEvent(QObject * object , int position , const QString & text )**

        Constructs a new QAccessibleTextInsertEvent event for **object**. The **text** has been inserted at **position**. By default, it is assumed that the cursor has moved to the end of the selection. If that is not the case, one needs to manually set it with **QAccessibleTextCursorEvent::setCursorPosition** () for this event.
        """
        ...

    @typing.overload
    def __init__(self, obj: PySide2.QtCore.QObject, position: int, text: str) -> None:
        """
        **QAccessibleTextInsertEvent::QAccessibleTextInsertEvent(QObject * object , int position , const QString & text )**

        Constructs a new QAccessibleTextInsertEvent event for **object**. The **text** has been inserted at **position**. By default, it is assumed that the cursor has moved to the end of the selection. If that is not the case, one needs to manually set it with **QAccessibleTextCursorEvent::setCursorPosition** () for this event.
        """
        ...

    def changePosition(self) -> int:
        """
        **int QAccessibleTextInsertEvent::changePosition() const**

        Returns the position where the text was inserted.
        """
        ...

    def textInserted(self) -> str:
        """
        **QString QAccessibleTextInsertEvent::textInserted() const**

        Returns the text that has been inserted.
        """
        ...
