"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui

bytes = str


class QOpenGLVersionProfile(object):
    """
    **Detailed Description**

    An object of this class can be passed to **QOpenGLContext::versionFunctions** () to request a functions object for a specific version and profile of OpenGL.

    It also contains some helper functions to check if a version supports profiles or is a legacy version.
    """

    @typing.overload
    def __init__(self) -> None:
        """
        **QOpenGLVersionProfile::QOpenGLVersionProfile()**

        Creates a default invalid QOpenGLVersionProfile object.
        """
        ...

    @typing.overload
    def __init__(self, format: PySide2.QtGui.QSurfaceFormat) -> None:
        """
        **QOpenGLVersionProfile::QOpenGLVersionProfile()**

        Creates a default invalid QOpenGLVersionProfile object.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtGui.QOpenGLVersionProfile) -> None:
        """
        **QOpenGLVersionProfile::QOpenGLVersionProfile()**

        Creates a default invalid QOpenGLVersionProfile object.
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    def hasProfiles(self) -> bool:
        """
        **bool QOpenGLVersionProfile::hasProfiles() const**

        Returns `true` if profiles are supported by the OpenGL version returned by **version** (). Only OpenGL versions >= 3.2 support profiles.

        **See also** **profile** () and **version** ().
        """
        ...

    def isLegacyVersion(self) -> bool:
        """
        **bool QOpenGLVersionProfile::isLegacyVersion() const**

        Returns `true` is the OpenGL version returned by **version** () contains deprecated functions and does not support profiles i.e. if the OpenGL version is <= 3.1.
        """
        ...

    def isValid(self) -> bool:
        """
        **bool QOpenGLVersionProfile::isValid() const**

        Returns `true` if the version number is valid. Note that for a default constructed **QOpenGLVersionProfile**  object this function will return `false`.

        **See also** **setVersion** () and **version** ().
        """
        ...

    def profile(self) -> PySide2.QtGui.QSurfaceFormat.OpenGLContextProfile:
        """
        **QSurfaceFormat::OpenGLContextProfile QOpenGLVersionProfile::profile() const**

        Returns the OpenGL profile. Only makes sense if profiles are supported by this version.

        **See also** **setProfile** ().
        """
        ...

    def setProfile(
        self, profile: PySide2.QtGui.QSurfaceFormat.OpenGLContextProfile
    ) -> None:
        """
        **void QOpenGLVersionProfile::setProfile(QSurfaceFormat::OpenGLContextProfile profile )**

        Sets the OpenGL profile **profile**. Only makes sense if profiles are supported by this version.

        **See also** **profile** ().
        """
        ...

    def setVersion(self, majorVersion: int, minorVersion: int) -> None:
        """
        **void QOpenGLVersionProfile::setVersion(int majorVersion , int minorVersion )**

        Sets the major and minor version numbers to **majorVersion** and **minorVersion** respectively.

        **See also** **version** ().
        """
        ...

    def version(self) -> typing.Tuple:
        """
        **QPair<int, int> QOpenGLVersionProfile::version() const**

        Returns a **QPair** <int,int> where the components represent the major and minor OpenGL version numbers respectively.

        **See also** **setVersion** ().
        """
        ...
