"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui

bytes = str


class QPainterPathStroker(object):
    """
    **Detailed Description**

    By calling the **createStroke** () function, passing a given **QPainterPath**  as argument, a new painter path representing the outline of the given path is created. The newly created painter path can then be filled to draw the original painter path's outline.

    You can control the various design aspects (width, cap styles, join styles and dash pattern) of the outlining using the following functions:

    * **setWidth** ()
      * **setCapStyle** ()
      * **setJoinStyle** ()
      * **setDashPattern** ()

    The **setDashPattern** () function accepts both a **Qt::PenStyle**  object and a vector representation of the pattern as argument.

    In addition you can specify a curve's threshold, controlling the granularity with which a curve is drawn, using the **setCurveThreshold** () function. The default threshold is a well adjusted value (0.25), and normally you should not need to modify it. However, you can make the curve's appearance smoother by decreasing its value.

    You can also control the miter limit for the generated outline using the **setMiterLimit** () function. The miter limit describes how far from each join the miter join can extend. The limit is specified in the units of width so the pixelwise miter limit will be `miterlimit * width`. This value is only used if the join style is **Qt::MiterJoin** .

    The painter path generated by the **createStroke** () function should only be used for outlining the given painter path. Otherwise it may cause unexpected behavior. Generated outlines also require the **Qt::WindingFill**  rule which is set by default.

    **See also** **QPen**  and **QBrush** .
    """

    @typing.overload
    def __init__(self) -> None:
        """
        **QPainterPathStroker::QPainterPathStroker()**

        Creates a new stroker.
        """
        ...

    @typing.overload
    def __init__(self, pen: PySide2.QtGui.QPen) -> None:
        """
        **QPainterPathStroker::QPainterPathStroker()**

        Creates a new stroker.
        """
        ...

    def capStyle(self) -> PySide2.QtCore.Qt.PenCapStyle:
        """
        **Qt::PenCapStyle QPainterPathStroker::capStyle() const**

        Returns the cap style of the generated outlines.

        **See also** **setCapStyle** ().
        """
        ...

    def createStroke(
        self, path: PySide2.QtGui.QPainterPath
    ) -> PySide2.QtGui.QPainterPath:
        """
        **QPainterPath QPainterPathStroker::createStroke(const QPainterPath & path ) const**

        Generates a new path that is a fillable area representing the outline of the given **path**.

        The various design aspects of the outline are based on the stroker's properties: **width** (), **capStyle** (), **joinStyle** (), **dashPattern** (), **curveThreshold** () and **miterLimit** ().

        The generated path should only be used for outlining the given painter path. Otherwise it may cause unexpected behavior. Generated outlines also require the **Qt::WindingFill**  rule which is set by default.
        """
        ...

    def curveThreshold(self) -> float:
        """
        **qreal QPainterPathStroker::curveThreshold() const**

        Returns the curve flattening threshold for the generated outlines.

        **See also** **setCurveThreshold** ().
        """
        ...

    def dashOffset(self) -> float:
        """
        **qreal QPainterPathStroker::dashOffset() const**

        Returns the dash offset for the generated outlines.

        **See also** **setDashOffset** ().
        """
        ...

    def dashPattern(self) -> typing.List:
        """
        **QVector<qreal> QPainterPathStroker::dashPattern() const**

        Returns the dash pattern for the generated outlines.

        **See also** **setDashPattern** ().
        """
        ...

    def joinStyle(self) -> PySide2.QtCore.Qt.PenJoinStyle:
        """
        **Qt::PenJoinStyle QPainterPathStroker::joinStyle() const**

        Returns the join style of the generated outlines.

        **See also** **setJoinStyle** ().
        """
        ...

    def miterLimit(self) -> float:
        """
        **qreal QPainterPathStroker::miterLimit() const**

        Returns the miter limit for the generated outlines.

        **See also** **setMiterLimit** ().
        """
        ...

    def setCapStyle(self, style: PySide2.QtCore.Qt.PenCapStyle) -> None:
        """
        **void QPainterPathStroker::setCapStyle(Qt::PenCapStyle style )**

        Sets the cap style of the generated outlines to **style**. If a dash pattern is set, each segment of the pattern is subject to the cap **style**.

        **See also** **capStyle** ().
        """
        ...

    def setCurveThreshold(self, threshold: float) -> None:
        """
        **void QPainterPathStroker::setCurveThreshold(qreal threshold )**

        Specifies the curve flattening **threshold** , controlling the granularity with which the generated outlines' curve is drawn.

        The default threshold is a well adjusted value (0.25), and normally you should not need to modify it. However, you can make the curve's appearance smoother by decreasing its value.

        **See also** **curveThreshold** ().
        """
        ...

    def setDashOffset(self, offset: float) -> None:
        """
        **void QPainterPathStroker::setDashOffset(qreal offset )**

        Sets the dash offset for the generated outlines to **offset**.

        See the documentation for **QPen::setDashOffset** () for a description of the dash offset.

        **See also** **dashOffset** ().
        """
        ...

    @typing.overload
    def setDashPattern(self, arg__1: PySide2.QtCore.Qt.PenStyle) -> None:
        """
        **void QPainterPathStroker::setDashPattern(Qt::PenStyle style )**

        Sets the dash pattern for the generated outlines to **style**.

        **See also** **dashPattern** ().
        """
        ...

    @typing.overload
    def setDashPattern(self, dashPattern: typing.List) -> None:
        """
        **void QPainterPathStroker::setDashPattern(Qt::PenStyle style )**

        Sets the dash pattern for the generated outlines to **style**.

        **See also** **dashPattern** ().
        """
        ...

    def setJoinStyle(self, style: PySide2.QtCore.Qt.PenJoinStyle) -> None:
        """
        **void QPainterPathStroker::setJoinStyle(Qt::PenJoinStyle style )**

        Sets the join style of the generated outlines to **style**.

        **See also** **joinStyle** ().
        """
        ...

    def setMiterLimit(self, length: float) -> None:
        """
        **void QPainterPathStroker::setMiterLimit(qreal limit )**

        Sets the miter limit of the generated outlines to **limit**.

        The miter limit describes how far from each join the miter join can extend. The limit is specified in units of the currently set width. So the pixelwise miter limit will be `miterlimit * width`.

        This value is only used if the join style is **Qt::MiterJoin** .

        **See also** **miterLimit** ().
        """
        ...

    def setWidth(self, width: float) -> None:
        """
        **void QPainterPathStroker::setWidth(qreal width )**

        Sets the width of the generated outline painter path to **width**.

        The generated outlines will extend approximately 50% of **width** to each side of the given input path's original outline.

        **See also** **width** ().
        """
        ...

    def width(self) -> float:
        """
        **qreal QPainterPathStroker::width() const**

        Returns the width of the generated outlines.

        **See also** **setWidth** ().
        """
        ...
