"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui

bytes = str


class QTextImageFormat(PySide2.QtGui.QTextCharFormat):
    """
    **Detailed Description**

    Inline images are represented by a Unicode value U+FFFC (OBJECT REPLACEMENT CHARACTER) which has an associated QTextImageFormat. The image format specifies a name with **setName** () that is used to locate the image. The size of the rectangle that the image will occupy is specified in pixels using **setWidth** () and **setHeight** (). The desired image quality may be set with **setQuality** ().

    Images can be supplied in any format for which Qt has an image reader, so SVG drawings can be included alongside PNG, TIFF and other bitmap formats.

    **See also** **QImage**  and **QImageReader** .
    """

    @typing.overload
    def __init__(self) -> None:
        """
        **QTextImageFormat::QTextImageFormat()**

        Creates a new image format object.
        """
        ...

    @typing.overload
    def __init__(self, QTextImageFormat: PySide2.QtGui.QTextImageFormat) -> None:
        """
        **QTextImageFormat::QTextImageFormat()**

        Creates a new image format object.
        """
        ...

    @typing.overload
    def __init__(self, format: PySide2.QtGui.QTextFormat) -> None:
        """
        **QTextImageFormat::QTextImageFormat()**

        Creates a new image format object.
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    def height(self) -> float:
        """
        **qreal QTextImageFormat::height() const**

        Returns the height of the rectangle occupied by the image.

        **See also** **width** () and **setHeight** ().
        """
        ...

    def isValid(self) -> bool:
        """
        **bool QTextImageFormat::isValid() const**

        Returns `true` if this image format is valid; otherwise returns `false`.
        """
        ...

    def name(self) -> str:
        """
        **QString QTextImageFormat::name() const**

        Returns the name of the image. The name refers to an entry in the application's resources file.

        **See also** **setName** ().
        """
        ...

    def quality(self) -> int:
        """
        **int QTextImageFormat::quality() const**

        Returns the value set by **setQuality** ().

        This function was introduced in Qt 5.12.

        **See also** **setQuality** ().
        """
        ...

    def setHeight(self, height: float) -> None:
        """
        **void QTextImageFormat::setHeight(qreal height )**

        Sets the **height** of the rectangle occupied by the image.

        **See also** **height** () and **setWidth** ().
        """
        ...

    def setName(self, name: str) -> None:
        """
        **void QTextImageFormat::setName(const QString & name )**

        Sets the **name** of the image. The **name** is used to locate the image in the application's resources.

        **See also** **name** ().
        """
        ...

    def setQuality(self, quality: int = ...) -> None:
        """
        **void QTextImageFormat::setQuality(int quality = 100)**

        Sets the quality that should be used by exporters when exporting the image. **QTextDocumentWriter**  will export jpg images with the **quality** set here when exporting to ODF files if **quality** is set to a value between 0 and 100. Or it will export png images if **quality** is set to 100 (default) or greater.

        This function was introduced in Qt 5.12.

        **See also** **quality** ().
        """
        ...

    def setWidth(self, width: float) -> None:
        """
        **void QTextImageFormat::setWidth(qreal width )**

        Sets the **width** of the rectangle occupied by the image.

        **See also** **width** () and **setHeight** ().
        """
        ...

    def width(self) -> float:
        """
        **qreal QTextImageFormat::width() const**

        Returns the width of the rectangle occupied by the image.

        **See also** **height** () and **setWidth** ().
        """
        ...
