"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets
import PySide2.QtHelp

bytes = str


class QCompressedHelpInfo(object):
    """
    **Detailed Description**

    The detailed information about the compressed help file can be fetched by calling the **fromCompressedHelpFile** () static method, providing the path to the compressed help file.

    The class provides access to various information about a compressed help file. The namespace associated with the given compressed help file is **namespaceName** (), the associated component name is **component** () and **version** () provides version information.

    **See also** **QHelpFilterEngine** .
    """

    @typing.overload
    def __init__(self) -> None:
        """
        **QCompressedHelpInfo::QCompressedHelpInfo()**

        Constructs empty information about a compressed help file.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtHelp.QCompressedHelpInfo) -> None:
        """
        **QCompressedHelpInfo::QCompressedHelpInfo()**

        Constructs empty information about a compressed help file.
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    def component(self) -> str:
        """
        **QString QCompressedHelpInfo::component() const**

        Returns the component of the compressed help file.
        """
        ...

    @staticmethod
    def fromCompressedHelpFile(
        documentationFileName: str,
    ) -> PySide2.QtHelp.QCompressedHelpInfo:
        """
        **[static] QCompressedHelpInfo QCompressedHelpInfo::fromCompressedHelpFile(const QString & documentationFileName )**

        Returns the **QCompressedHelpInfo**  instance for the **documentationFileName** of the existing qch file.
        """
        ...

    def isNull(self) -> bool:
        """
        **bool QCompressedHelpInfo::isNull() const**

        Returns `true` if the info is invalid, otherwise returns `false`.
        """
        ...

    def namespaceName(self) -> str:
        """
        **QString QCompressedHelpInfo::namespaceName() const**

        Returns the namespace name of the compressed help file.
        """
        ...

    def swap(self, other: PySide2.QtHelp.QCompressedHelpInfo) -> None:
        """
        **void QCompressedHelpInfo::swap(QCompressedHelpInfo & other )**

        Swaps the compressed help file **other** with this compressed help file. This operation is very fast and never fails.
        """
        ...

    def version(self) -> PySide2.QtCore.QVersionNumber:
        """
        **QVersionNumber QCompressedHelpInfo::version() const**

        Returns the version of the compressed help file.
        """
        ...
