"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets
import PySide2.QtHelp

bytes = str


class QHelpFilterSettingsWidget(PySide2.QtWidgets.QWidget):
    """
    **Detailed Description**

    The instance of QHelpFilterSettingsWidget may be a part of a preferences dialog. Before showing the dialog, **setAvailableComponents** () and **setAvailableVersions** () should be called, otherwise the filter settings widget will only offer a creation of empty filters, which wouldn't be useful. In addition, **readSettings**  should also be called to fill up the filter settings widget with the list of filters already stored in the filter engine. The creation of new filters, modifications to existing filters and removal of unneeded filters are handled by the widget automatically. If you want to store the current state of the widget and apply it to the filter engine e.g. after the user clicked the apply button - call **applySettings** ().
    """

    def __init__(
        self, parent: typing.Optional[PySide2.QtWidgets.QWidget] = ...
    ) -> None:
        """
        **QHelpFilterSettingsWidget::QHelpFilterSettingsWidget(QWidget * parent = nullptr)**

        Constructs a filter settings widget with **parent** as parent widget.
        """
        ...

    def applySettings(self, filterEngine: PySide2.QtHelp.QHelpFilterEngine) -> bool:
        """
        **bool QHelpFilterSettingsWidget::applySettings(QHelpFilterEngine * filterEngine ) const**

        Writes the filter settings, currently presented in this filter settings widget, to the **filterEngine**. The old settings stored in the filter engine will be overwritten.
        """
        ...

    def readSettings(self, filterEngine: PySide2.QtHelp.QHelpFilterEngine) -> None:
        """
        **void QHelpFilterSettingsWidget::readSettings(const QHelpFilterEngine * filterEngine )**

        Reads the filter settings stored inside **filterEngine** and sets up this filter settings widget accordingly.
        """
        ...

    def setAvailableComponents(self, components: typing.Sequence) -> None:
        """
        **void QHelpFilterSettingsWidget::setAvailableComponents(const QStringList & components )**

        Sets the list of all available components to **components**.

        **See also** **QHelpFilterEngine::availableComponents** ().
        """
        ...

    def setAvailableVersions(self, versions: typing.Sequence) -> None:
        """
        **void QHelpFilterSettingsWidget::setAvailableVersions(const QList<QVersionNumber> & versions )**

        Sets the list of all available version numbers to **versions**.

        **See also** **QHelpFilterEngine::availableVersions** ().
        """
        ...
