"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtPositioning
import PySide2.QtLocation

bytes = str


class QPlaceImage(PySide2.QtLocation.QPlaceContent):
    """
    **Detailed Description**

    Each QPlaceImage represents a set of metadata about an image such as it's url, identifier and MIME type. These are properties in addition to those provided by **QPlaceContent** .

    Note: The Places API only supports images as 'retrieve-only' objects. Submitting images to a provider is not a supported use case.

    **See also** **QPlaceContent** .
    """

    @typing.overload
    def __init__(self) -> None:
        """
        **QPlaceImage::QPlaceImage()**

        Constructs an new QPlaceImage.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtLocation.QPlaceContent) -> None:
        """
        **QPlaceImage::QPlaceImage()**

        Constructs an new QPlaceImage.
        """
        ...

    def imageId(self) -> str:
        """
        **QString QPlaceImage::imageId() const**

        Returns the image's identifier.

        **See also** **setImageId** ().
        """
        ...

    def mimeType(self) -> str:
        """
        **QString QPlaceImage::mimeType() const**

        Returns the image's MIME type.

        **See also** **setMimeType** ().
        """
        ...

    def setImageId(self, identifier: str) -> None:
        """
        **void QPlaceImage::setImageId(const QString & identifier )**

        Sets image's **identifier**.

        **See also** **imageId** ().
        """
        ...

    def setMimeType(self, data: str) -> None:
        """
        **void QPlaceImage::setMimeType(const QString & type )**

        Sets image's MIME **type**.

        **See also** **mimeType** ().
        """
        ...

    def setUrl(self, url: PySide2.QtCore.QUrl) -> None:
        """
        **void QPlaceImage::setUrl(const QUrl & url )**

        Sets the image's **url**.

        **See also** **url** ().
        """
        ...

    def url(self) -> PySide2.QtCore.QUrl:
        """
        **QUrl QPlaceImage::url() const**

        Returns the image's url.

        **See also** **setUrl** ().
        """
        ...
