"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtNetwork
import PySide2.QtMultimediaWidgets
import PySide2.QtMultimedia

bytes = str


class QCameraImageCaptureControl(PySide2.QtMultimedia.QMediaControl):
    """
    **Detailed Description**

    The interface name of QCameraImageCaptureControl is `org.qt-project.qt.cameraimagecapturecontrol/5.0` as defined in **QCameraImageCaptureControl_iid** .

    **See also** **QMediaService::requestControl** ().
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        **[protected] QCameraImageCaptureControl::QCameraImageCaptureControl(QObject * parent = nullptr)**

        Constructs a new image capture control object with the given **parent**
        """
        ...

    def cancelCapture(self) -> None:
        """
        **[pure virtual] void QCameraImageCaptureControl::cancelCapture()**

        Cancel pending capture requests.
        """
        ...

    def capture(self, fileName: str) -> int:
        """
        **[pure virtual] int QCameraImageCaptureControl::capture(const QString & fileName )**

        Initiates the capture of an image to **fileName**. The **fileName** can be relative or empty, in this case the service should use the system specific place and file naming scheme.

        The Camera service should save all the capture parameters like exposure settings or image processing parameters, so changes to camera parameters after capture() is called do not affect previous capture requests.

        Returns the capture request id number, which is used later with **imageExposed** (), **imageCaptured** () and **imageSaved** () signals.
        """
        ...

    def driveMode(self) -> PySide2.QtMultimedia.QCameraImageCapture.DriveMode:
        """
        **[pure virtual] QCameraImageCapture::DriveMode QCameraImageCaptureControl::driveMode() const**

        Returns the current camera drive mode.

        **See also** **setDriveMode** ().
        """
        ...

    def isReadyForCapture(self) -> bool:
        """
        **[pure virtual] bool QCameraImageCaptureControl::isReadyForCapture() const**

        Identifies if a capture control is ready to perform a capture immediately (all the resources necessary for image capture are allocated, hardware initialized, flash is charged, etc).

        Returns true if the camera is ready for capture; and false if it is not.

        It's permissible to call **capture** () while the camera status is **QCamera::ActiveStatus**  regardless of isReadyForCapture property value. If camera is not ready to capture image immediately, the capture request is queued with all the related camera settings to be executed as soon as possible.
        """
        ...

    def setDriveMode(
        self, mode: PySide2.QtMultimedia.QCameraImageCapture.DriveMode
    ) -> None:
        """
        **[pure virtual] void QCameraImageCaptureControl::setDriveMode(QCameraImageCapture::DriveMode mode )**

        Sets the current camera drive **mode**.

        **See also** **driveMode** ().
        """
        ...

    @property
    def error(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QCameraImageCaptureControl::error(int id , int error , const QString & errorString )**

        Signals the capture request **id** failed with **error** code and message **errorString**.

        **See also** **QCameraImageCapture::Error** .
        """
        ...

    @property
    def imageAvailable(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QCameraImageCaptureControl::imageAvailable(int requestId , const QVideoFrame & buffer )**

        Signals that a captured **buffer** with a **requestId** is available.
        """
        ...

    @property
    def imageCaptured(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QCameraImageCaptureControl::imageCaptured(int requestId , const QImage & preview )**

        Signals that an image with it **requestId** has been captured and a **preview** is available.
        """
        ...

    @property
    def imageExposed(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QCameraImageCaptureControl::imageExposed(int requestId )**

        Signals that an image with it **requestId** has just been exposed. This signal can be used for the shutter sound or other indicaton.
        """
        ...

    @property
    def imageMetadataAvailable(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QCameraImageCaptureControl::imageMetadataAvailable(int id , const QString & key , const QVariant & value )**

        Signals that a metadata for an image with request **id** is available. Signal also contains the **key** and **value** of the metadata.

        This signal should be emitted between **imageExposed**  and **imageSaved**  signals.
        """
        ...

    @property
    def imageSaved(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QCameraImageCaptureControl::imageSaved(int requestId , const QString & fileName )**

        Signals that a captured image with a **requestId** has been saved to **fileName**.
        """
        ...

    @property
    def readyForCaptureChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QCameraImageCaptureControl::readyForCaptureChanged(bool ready )**

        Signals that a capture control's **ready** state has changed.
        """
        ...
