"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtNetwork
import PySide2.QtMultimediaWidgets
import PySide2.QtMultimedia

bytes = str


class QImageEncoderControl(PySide2.QtMultimedia.QMediaControl):
    """
    **Detailed Description**

    If a **QMediaService**  supports encoding image data it will implement QImageEncoderControl. This control allows to **set image encoding settings**  and provides functions for quering supported image **codecs**  and **resolutions** .

    The interface name of QImageEncoderControl is `org.qt-project.qt.imageencodercontrol/5.0` as defined in **QImageEncoderControl_iid** .

    **See also** **QImageEncoderSettings**  and **QMediaService::requestControl** ().
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        **[protected] QImageEncoderControl::QImageEncoderControl(QObject * parent = nullptr)**

        Constructs a new image encoder control object with the given **parent**
        """
        ...

    def imageCodecDescription(self, codec: str) -> str:
        """
        **[pure virtual] QString QImageEncoderControl::imageCodecDescription(const QString & codec ) const**

        Returns a description of an image **codec**.
        """
        ...

    def imageSettings(self) -> PySide2.QtMultimedia.QImageEncoderSettings:
        """
        **[pure virtual] QImageEncoderSettings QImageEncoderControl::imageSettings() const**

        Returns the currently used image encoder settings.

        The returned value may be different tha passed to **QImageEncoderControl::setImageSettings** () if the settings contains the default or undefined parameters. In this case if the undefined parameters are already resolved, they should be returned.

        **See also** **setImageSettings** ().
        """
        ...

    def setImageSettings(
        self, settings: PySide2.QtMultimedia.QImageEncoderSettings
    ) -> None:
        """
        **[pure virtual] void QImageEncoderControl::setImageSettings(const QImageEncoderSettings & settings )**

        Sets the selected image encoder **settings**.

        **See also** **imageSettings** ().
        """
        ...

    def supportedImageCodecs(self) -> typing.List:
        """
        **[pure virtual] QStringList QImageEncoderControl::supportedImageCodecs() const**

        Returns a list of supported image codecs.
        """
        ...
