"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtNetwork
import PySide2.QtMultimediaWidgets
import PySide2.QtMultimedia

bytes = str


class QMediaResource(object):
    """
    **Detailed Description**

    A media resource is composed of a **URL**  containing the location of the resource and a set of properties that describe the format of the resource. The properties provide a means to assess a resource without first attempting to load it, and in situations where media be represented by multiple alternative representations provide a means to select the appropriate resource.

    Media made available by a remote services can often be available in multiple encodings or quality levels, this allows a client to select an appropriate resource based on considerations such as codecs supported, network bandwidth, and display constraints. QMediaResource includes information such as the **MIME type** , **audio**  and **video**  codecs, **audio**  and **video**  bit rates, and **resolution**  so these constraints and others can be evaluated.

    The only mandatory property of a QMediaResource is the **url** ().

    **See also** **QMediaContent** .
    """

    @typing.overload
    def __init__(self) -> None:
        """
        **QMediaResource::QMediaResource()**

        Constructs a null media resource.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtMultimedia.QMediaResource) -> None:
        """
        **QMediaResource::QMediaResource()**

        Constructs a null media resource.
        """
        ...

    @typing.overload
    def __init__(
        self, request: PySide2.QtNetwork.QNetworkRequest, mimeType: str = ...
    ) -> None:
        """
        **QMediaResource::QMediaResource()**

        Constructs a null media resource.
        """
        ...

    @typing.overload
    def __init__(self, url: PySide2.QtCore.QUrl, mimeType: str = ...) -> None:
        """
        **QMediaResource::QMediaResource()**

        Constructs a null media resource.
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    def audioBitRate(self) -> int:
        """
        **int QMediaResource::audioBitRate() const**

        Returns the bit rate in bits per second of a media resource's audio stream.

        This may be zero if the bit rate is unknown, or the resource contains no audio stream.

        **See also** **setAudioBitRate** ().
        """
        ...

    def audioCodec(self) -> str:
        """
        **QString QMediaResource::audioCodec() const**

        Returns the audio codec of a media resource.

        This may be null if the media resource does not contain an audio stream, or the codec is unknown.

        **See also** **setAudioCodec** ().
        """
        ...

    def channelCount(self) -> int:
        """
        **int QMediaResource::channelCount() const**

        Returns the number of audio channels in a media resource.

        This may be zero if the sample size is unknown, or the resource contains no audio stream.

        **See also** **setChannelCount** ().
        """
        ...

    def dataSize(self) -> int:
        """
        **qint64 QMediaResource::dataSize() const**

        Returns the size in bytes of a media resource.

        This may be zero if the size is unknown.

        **See also** **setDataSize** ().
        """
        ...

    def isNull(self) -> bool:
        """
        **bool QMediaResource::isNull() const**

        Identifies if a media resource is null.

        Returns true if the resource is null, and false otherwise.
        """
        ...

    def language(self) -> str:
        """
        **QString QMediaResource::language() const**

        Returns the language of a media resource as an ISO 639-2 code.

        This may be null if the language is unknown.

        **See also** **setLanguage** ().
        """
        ...

    def mimeType(self) -> str:
        """
        **QString QMediaResource::mimeType() const**

        Returns the MIME type of a media resource.

        This may be null if the MIME type is unknown.
        """
        ...

    def request(self) -> PySide2.QtNetwork.QNetworkRequest:
        """
        **QNetworkRequest QMediaResource::request() const**

        Returns the network request associated with this media resource.
        """
        ...

    def resolution(self) -> PySide2.QtCore.QSize:
        """
        **QSize QMediaResource::resolution() const**

        Returns the resolution in pixels of a media resource.

        This may be null is the resolution is unknown, or the resource contains no pixel data (i.e. the resource is an audio stream.

        **See also** **setResolution** ().
        """
        ...

    def sampleRate(self) -> int:
        """
        **int QMediaResource::sampleRate() const**

        Returns the audio sample rate of a media resource.

        This may be zero if the sample size is unknown, or the resource contains no audio stream.

        **See also** **setSampleRate** ().
        """
        ...

    def setAudioBitRate(self, rate: int) -> None:
        """
        **void QMediaResource::setAudioBitRate(int rate )**

        Sets the bit **rate** in bits per second of a media resource's video stream.

        **See also** **audioBitRate** ().
        """
        ...

    def setAudioCodec(self, codec: str) -> None:
        """
        **void QMediaResource::setAudioCodec(const QString & codec )**

        Sets the audio **codec** of a media resource.

        **See also** **audioCodec** ().
        """
        ...

    def setChannelCount(self, channels: int) -> None:
        """
        **void QMediaResource::setChannelCount(int channels )**

        Sets the number of audio **channels** in a media resource.

        **See also** **channelCount** ().
        """
        ...

    def setDataSize(self, size: int) -> None:
        """
        **void QMediaResource::setDataSize(const qint64 size )**

        Sets the **size** in bytes of a media resource.

        **See also** **dataSize** ().
        """
        ...

    def setLanguage(self, language: str) -> None:
        """
        **void QMediaResource::setLanguage(const QString & language )**

        Sets the **language** of a media resource.

        **See also** **language** ().
        """
        ...

    @typing.overload
    def setResolution(self, resolution: PySide2.QtCore.QSize) -> None:
        """
        **void QMediaResource::setResolution(const QSize & resolution )**

        Sets the **resolution** in pixels of a media resource.

        **See also** **resolution** ().
        """
        ...

    @typing.overload
    def setResolution(self, width: int, height: int) -> None:
        """
        **void QMediaResource::setResolution(const QSize & resolution )**

        Sets the **resolution** in pixels of a media resource.

        **See also** **resolution** ().
        """
        ...

    def setSampleRate(self, frequency: int) -> None:
        """
        **void QMediaResource::setSampleRate(int sampleRate )**

        Sets the audio **sampleRate** of a media resource.

        **See also** **sampleRate** ().
        """
        ...

    def setVideoBitRate(self, rate: int) -> None:
        """
        **void QMediaResource::setVideoBitRate(int rate )**

        Sets the bit **rate** in bits per second of a media resource's video stream.

        **See also** **videoBitRate** ().
        """
        ...

    def setVideoCodec(self, codec: str) -> None:
        """
        **void QMediaResource::setVideoCodec(const QString & codec )**

        Sets the video **codec** of media resource.

        **See also** **videoCodec** ().
        """
        ...

    def url(self) -> PySide2.QtCore.QUrl:
        """
        **QUrl QMediaResource::url() const**

        Returns the URL of a media resource.
        """
        ...

    def videoBitRate(self) -> int:
        """
        **int QMediaResource::videoBitRate() const**

        Returns the bit rate in bits per second of a media resource's video stream.

        This may be zero if the bit rate is unknown, or the resource contains no video stream.

        **See also** **setVideoBitRate** ().
        """
        ...

    def videoCodec(self) -> str:
        """
        **QString QMediaResource::videoCodec() const**

        Returns the video codec of a media resource.

        This may be null if the media resource does not contain a video stream, or the codec is unknonwn.

        **See also** **setVideoCodec** ().
        """
        ...
