"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtNetwork
import PySide2.QtMultimediaWidgets
import PySide2.QtMultimedia

bytes = str


class QRadioDataControl(PySide2.QtMultimedia.QMediaControl):
    """
    **Detailed Description**

    The functionality provided by this control is exposed to application code through the **QRadioData**  class.

    The interface name of QRadioDataControl is `org.qt-project.qt.radiodatacontrol/5.0` as defined in **QRadioDataControl_iid** .

    **See also** **QMediaService::requestControl** () and **QRadioData** .
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        **[protected] QRadioDataControl::QRadioDataControl(QObject * parent = nullptr)**

        Constructs a radio data control with the given **parent**.
        """
        ...

    def error(self) -> PySide2.QtMultimedia.QRadioData.Error:
        """
        **[pure virtual] QRadioData::Error QRadioDataControl::error() const**

        Returns the error state of a radio data.
        """
        ...

    def errorString(self) -> str:
        """
        **[pure virtual] QString QRadioDataControl::errorString() const**

        Returns a string describing a radio data's error state.
        """
        ...

    def isAlternativeFrequenciesEnabled(self) -> bool:
        """
        **[pure virtual] bool QRadioDataControl::isAlternativeFrequenciesEnabled() const**

        Returns true if Alternative Frequency is currently enabled
        """
        ...

    def programType(self) -> PySide2.QtMultimedia.QRadioData.ProgramType:
        """
        **[pure virtual] QRadioData::ProgramType QRadioDataControl::programType() const**

        Returns the current Program Type
        """
        ...

    def programTypeName(self) -> str:
        """
        **[pure virtual] QString QRadioDataControl::programTypeName() const**

        Returns the current Program Type Name
        """
        ...

    def radioText(self) -> str:
        """
        **[pure virtual] QString QRadioDataControl::radioText() const**

        Returns the current Radio Text
        """
        ...

    def setAlternativeFrequenciesEnabled(self, enabled: bool) -> None:
        """
        **[pure virtual] void QRadioDataControl::setAlternativeFrequenciesEnabled(bool enabled )**

        Sets the Alternative Frequency to **enabled**

        **See also** **isAlternativeFrequenciesEnabled** ().
        """
        ...

    def stationId(self) -> str:
        """
        **[pure virtual] QString QRadioDataControl::stationId() const**

        Returns the current Program Identification
        """
        ...

    def stationName(self) -> str:
        """
        **[pure virtual] QString QRadioDataControl::stationName() const**

        Returns the current Program Service
        """
        ...

    @property
    def alternativeFrequenciesEnabledChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QRadioDataControl::alternativeFrequenciesEnabledChanged(bool enabled )**

        Signals that the alternative frequencies setting has changed to the value of **enabled**.
        """
        ...

    @property
    def error(self) -> PySide2.QtCore.SignalInstance:
        """
        **[pure virtual] QRadioData::Error QRadioDataControl::error() const**

        Returns the error state of a radio data.
        """
        ...

    @property
    def programTypeChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QRadioDataControl::programTypeChanged(QRadioData::ProgramType programType )**

        Signals that the Program Type **programType** has changed
        """
        ...

    @property
    def programTypeNameChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QRadioDataControl::programTypeNameChanged(QString programTypeName )**

        Signals that the Program Type Name **programTypeName** has changed
        """
        ...

    @property
    def radioTextChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QRadioDataControl::radioTextChanged(QString radioText )**

        Signals that the Radio Text **radioText** has changed
        """
        ...

    @property
    def stationIdChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QRadioDataControl::stationIdChanged(QString stationId )**

        Signals that the Program Identification **stationId** has changed
        """
        ...

    @property
    def stationNameChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QRadioDataControl::stationNameChanged(QString stationName )**

        Signals that the Program Service **stationName** has changed
        """
        ...
