"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtNetwork
import PySide2.QtMultimediaWidgets
import PySide2.QtMultimedia

bytes = str


class QVideoEncoderSettingsControl(PySide2.QtMultimedia.QMediaControl):
    """
    **Detailed Description**

    If a **QMediaService**  supports encoding video data it will implement QVideoEncoderSettingsControl. This control provides information about the limits of restricted video encoder options and allows the selection of a set of video encoder settings as specified in a **QVideoEncoderSettings**  object.

    The functionality provided by this control is exposed to application code through the **QMediaRecorder**  class.

    The interface name of QVideoEncoderSettingsControl is `org.qt-project.qt.videoencodersettingscontrol/5.0` as defined in **QVideoEncoderSettingsControl_iid** .

    **See also** **QMediaRecorder** , **QVideoEncoderSettings** , and **QMediaService::requestControl** ().
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        **[protected] QVideoEncoderSettingsControl::QVideoEncoderSettingsControl(QObject * parent = nullptr)**

        Create a new video encoder settings control object with the given **parent**.
        """
        ...

    def setVideoSettings(
        self, settings: PySide2.QtMultimedia.QVideoEncoderSettings
    ) -> None:
        """
        **[pure virtual] void QVideoEncoderSettingsControl::setVideoSettings(const QVideoEncoderSettings & settings )**

        Sets the selected video encoder **settings**.

        **See also** **videoSettings** ().
        """
        ...

    def supportedVideoCodecs(self) -> typing.List:
        """
        **[pure virtual] QStringList QVideoEncoderSettingsControl::supportedVideoCodecs() const**

        Returns the list of supported video codecs.
        """
        ...

    def videoCodecDescription(self, codec: str) -> str:
        """
        **[pure virtual] QString QVideoEncoderSettingsControl::videoCodecDescription(const QString & codec ) const**

        Returns a description of a video **codec**.
        """
        ...

    def videoSettings(self) -> PySide2.QtMultimedia.QVideoEncoderSettings:
        """
        **[pure virtual] QVideoEncoderSettings QVideoEncoderSettingsControl::videoSettings() const**

        Returns the video encoder settings.

        The returned value may be different tha passed to **QVideoEncoderSettingsControl::setVideoSettings** () if the settings contains the default or undefined parameters. In this case if the undefined parameters are already resolved, they should be returned.

        **See also** **setVideoSettings** ().
        """
        ...
