"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtNetwork
import PySide2.QtMultimediaWidgets
import PySide2.QtMultimedia

bytes = str


class QVideoWindowControl(PySide2.QtMultimedia.QMediaControl):
    """
    **Detailed Description**

    The **winId** () property QVideoWindowControl allows a platform specific window ID to be set as the video render target of a **QMediaService** . The **displayRect** () property is used to set the region of the window the video should be rendered to, and the **aspectRatioMode** () property indicates how the video should be scaled to fit the **displayRect** ().

    **QVideoWindowControl**  *windowControl = mediaService->requestControl<**QVideoWindowControl**  *>();
        windowControl->setWinId(widget->winId());
        windowControl->setDisplayRect(widget->rect());
        windowControl->setAspectRatioMode(Qt::KeepAspectRatio);

    QVideoWindowControl is one of a number of possible video output controls.

    The interface name of QVideoWindowControl is `org.qt-project.qt.videowindowcontrol/5.0` as defined in **QVideoWindowControl_iid** .

    **See also** **QMediaService::requestControl** () and **QVideoWidget** .
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        **[protected] QVideoWindowControl::QVideoWindowControl(QObject * parent = nullptr)**

        Constructs a new video window control with the given **parent**.
        """
        ...

    def aspectRatioMode(self) -> PySide2.QtCore.Qt.AspectRatioMode:
        """
        **[pure virtual] Qt::AspectRatioMode QVideoWindowControl::aspectRatioMode() const**

        Returns how video is scaled to fit the display region with respect to its aspect ratio.

        **See also** **setAspectRatioMode** ().
        """
        ...

    def brightness(self) -> int:
        """
        **[pure virtual] int QVideoWindowControl::brightness() const**

        Returns the brightness adjustment applied to a video overlay.

        Valid brightness values range between -100 and 100, the default is 0.

        **See also** **setBrightness** ().
        """
        ...

    def contrast(self) -> int:
        """
        **[pure virtual] int QVideoWindowControl::contrast() const**

        Returns the contrast adjustment applied to a video overlay.

        Valid contrast values range between -100 and 100, the default is 0.

        **See also** **setContrast** ().
        """
        ...

    def displayRect(self) -> PySide2.QtCore.QRect:
        """
        **[pure virtual] QRect QVideoWindowControl::displayRect() const**

        Returns the sub-rect of a window where video is displayed.

        **See also** **setDisplayRect** ().
        """
        ...

    def hue(self) -> int:
        """
        **[pure virtual] int QVideoWindowControl::hue() const**

        Returns the hue adjustment applied to a video overlay.

        Value hue values range between -100 and 100, the default is 0.

        **See also** **setHue** ().
        """
        ...

    def isFullScreen(self) -> bool:
        """
        **[pure virtual] bool QVideoWindowControl::isFullScreen() const**

        Identifies if a video overlay is a fullScreen overlay.

        Returns true if the video overlay is fullScreen, and false otherwise.
        """
        ...

    def nativeSize(self) -> PySide2.QtCore.QSize:
        """
        **[pure virtual] QSize QVideoWindowControl::nativeSize() const**

        Returns a suggested size for the video display based on the resolution and aspect ratio of the video.
        """
        ...

    def repaint(self) -> None:
        """
        **[pure virtual] void QVideoWindowControl::repaint()**

        Repaints the last frame.
        """
        ...

    def saturation(self) -> int:
        """
        **[pure virtual] int QVideoWindowControl::saturation() const**

        Returns the saturation adjustment applied to a video overlay.

        Value saturation values range between -100 and 100, the default is 0.

        **See also** **setSaturation** ().
        """
        ...

    def setAspectRatioMode(self, mode: PySide2.QtCore.Qt.AspectRatioMode) -> None:
        """
        **[pure virtual] void QVideoWindowControl::setAspectRatioMode(Qt::AspectRatioMode mode )**

        Sets the aspect ratio **mode** which determines how video is scaled to the fit the display region with respect to its aspect ratio.

        **See also** **aspectRatioMode** ().
        """
        ...

    def setBrightness(self, brightness: int) -> None:
        """
        **[pure virtual] void QVideoWindowControl::setBrightness(int brightness )**

        Sets a **brightness** adjustment for a video overlay.

        Valid brightness values range between -100 and 100, the default is 0.

        **See also** **brightness** ().
        """
        ...

    def setContrast(self, contrast: int) -> None:
        """
        **[pure virtual] void QVideoWindowControl::setContrast(int contrast )**

        Sets the **contrast** adjustment for a video overlay.

        Valid contrast values range between -100 and 100, the default is 0.

        **See also** **contrast** ().
        """
        ...

    def setDisplayRect(self, rect: PySide2.QtCore.QRect) -> None:
        """
        **[pure virtual] void QVideoWindowControl::setDisplayRect(const QRect & rect )**

        Sets the sub- **rect** of a window where video is displayed.

        **See also** **displayRect** ().
        """
        ...

    def setFullScreen(self, fullScreen: bool) -> None:
        """
        **[pure virtual] void QVideoWindowControl::setFullScreen(bool fullScreen )**

        Sets whether a video overlay is a **fullScreen** overlay.

        **See also** **isFullScreen** ().
        """
        ...

    def setHue(self, hue: int) -> None:
        """
        **[pure virtual] void QVideoWindowControl::setHue(int hue )**

        Sets a **hue** adjustment for a video overlay.

        Valid hue values range between -100 and 100, the default is 0.

        **See also** **hue** ().
        """
        ...

    def setSaturation(self, saturation: int) -> None:
        """
        **[pure virtual] void QVideoWindowControl::setSaturation(int saturation )**

        Sets a **saturation** adjustment for a video overlay.

        Valid saturation values range between -100 and 100, the default is 0.

        **See also** **saturation** ().
        """
        ...

    def setWinId(self, id: int) -> None:
        """
        **[pure virtual] void QVideoWindowControl::setWinId(WId id )**

        Sets the **id** of the window a video overlay end point renders to.

        **See also** **winId** ().
        """
        ...

    def winId(self) -> int:
        """
        **[pure virtual] WId QVideoWindowControl::winId() const**

        Returns the ID of the window a video overlay end point renders to.

        **See also** **setWinId** ().
        """
        ...

    @property
    def brightnessChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QVideoWindowControl::brightnessChanged(int brightness )**

        Signals that a video overlay's **brightness** adjustment has changed.
        """
        ...

    @property
    def contrastChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QVideoWindowControl::contrastChanged(int contrast )**

        Signals that a video overlay's **contrast** adjustment has changed.
        """
        ...

    @property
    def fullScreenChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QVideoWindowControl::fullScreenChanged(bool fullScreen )**

        Signals that the **fullScreen** state of a video overlay has changed.
        """
        ...

    @property
    def hueChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QVideoWindowControl::hueChanged(int hue )**

        Signals that a video overlay's **hue** adjustment has changed.
        """
        ...

    @property
    def nativeSizeChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QVideoWindowControl::nativeSizeChanged()**

        Signals that the native dimensions of the video have changed.
        """
        ...

    @property
    def saturationChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        **[signal] void QVideoWindowControl::saturationChanged(int saturation )**

        Signals that a video overlay's **saturation** adjustment has changed.
        """
        ...
