"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtPositioning

bytes = str


class QGeoSatelliteInfo(object):
    """
    **Detailed Description**

    **See also** **QGeoSatelliteInfoSource** .
    """

    Elevation: QGeoSatelliteInfo = ...
    Undefined: QGeoSatelliteInfo = ...
    Azimuth: QGeoSatelliteInfo = ...
    GPS: QGeoSatelliteInfo = ...
    GLONASS: QGeoSatelliteInfo = ...

    class Attribute(object):
        Elevation: QGeoSatelliteInfo.Attribute = ...
        Azimuth: QGeoSatelliteInfo.Attribute = ...

    class SatelliteSystem(object):
        Undefined: QGeoSatelliteInfo.SatelliteSystem = ...
        GPS: QGeoSatelliteInfo.SatelliteSystem = ...
        GLONASS: QGeoSatelliteInfo.SatelliteSystem = ...

    @typing.overload
    def __init__(self) -> None:
        """
        **QGeoSatelliteInfo::QGeoSatelliteInfo()**

        Creates a satellite information object.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtPositioning.QGeoSatelliteInfo) -> None:
        """
        **QGeoSatelliteInfo::QGeoSatelliteInfo()**

        Creates a satellite information object.
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    def __lshift__(
        self, stream: PySide2.QtCore.QDataStream
    ) -> PySide2.QtCore.QDataStream:
        ...

    def __rshift__(
        self, stream: PySide2.QtCore.QDataStream
    ) -> PySide2.QtCore.QDataStream:
        ...

    def attribute(
        self, attribute: PySide2.QtPositioning.QGeoSatelliteInfo.Attribute
    ) -> float:
        """
        **qreal QGeoSatelliteInfo::attribute(QGeoSatelliteInfo::Attribute attribute ) const**

        Returns the value of the specified **attribute** as a qreal value.

        Returns -1 if the value has not been set.

        **See also** **hasAttribute** () and **setAttribute** ().
        """
        ...

    def hasAttribute(
        self, attribute: PySide2.QtPositioning.QGeoSatelliteInfo.Attribute
    ) -> bool:
        """
        **bool QGeoSatelliteInfo::hasAttribute(QGeoSatelliteInfo::Attribute attribute ) const**

        Returns true if the specified **attribute** is present in this update.
        """
        ...

    def removeAttribute(
        self, attribute: PySide2.QtPositioning.QGeoSatelliteInfo.Attribute
    ) -> None:
        """
        **void QGeoSatelliteInfo::removeAttribute(QGeoSatelliteInfo::Attribute attribute )**

        Removes the specified **attribute** and its value.
        """
        ...

    def satelliteIdentifier(self) -> int:
        """
        **int QGeoSatelliteInfo::satelliteIdentifier() const**

        Returns the satellite identifier number.

        The satellite identifier number can be used to identify a satellite inside the satellite system. For satellite system GPS the satellite identifier number represents the PRN (Pseudo-random noise) number. For satellite system GLONASS the satellite identifier number represents the slot number.

        **See also** **setSatelliteIdentifier** ().
        """
        ...

    def satelliteSystem(
        self,
    ) -> PySide2.QtPositioning.QGeoSatelliteInfo.SatelliteSystem:
        """
        **QGeoSatelliteInfo::SatelliteSystem QGeoSatelliteInfo::satelliteSystem() const**

        Returns the Satellite System (GPS, GLONASS, ...)

        **See also** **setSatelliteSystem** ().
        """
        ...

    def setAttribute(
        self, attribute: PySide2.QtPositioning.QGeoSatelliteInfo.Attribute, value: float
    ) -> None:
        """
        **void QGeoSatelliteInfo::setAttribute(QGeoSatelliteInfo::Attribute attribute , qreal value )**

        Sets the value for **attribute** to **value**.

        **See also** **attribute** ().
        """
        ...

    def setSatelliteIdentifier(self, satId: int) -> None:
        """
        **void QGeoSatelliteInfo::setSatelliteIdentifier(int satId )**

        Sets the satellite identifier number to **satId**.

        The satellite identifier number can be used to identify a satellite inside the satellite system. For satellite system GPS the satellite identifier number represents the PRN (Pseudo-random noise) number. For satellite system GLONASS the satellite identifier number represents the slot number.

        **See also** **satelliteIdentifier** ().
        """
        ...

    def setSatelliteSystem(
        self, system: PySide2.QtPositioning.QGeoSatelliteInfo.SatelliteSystem
    ) -> None:
        """
        **void QGeoSatelliteInfo::setSatelliteSystem(QGeoSatelliteInfo::SatelliteSystem system )**

        Sets the Satellite System (GPS, GLONASS, ...) to **system**.

        **See also** **satelliteSystem** ().
        """
        ...

    def setSignalStrength(self, signalStrength: int) -> None:
        """
        **void QGeoSatelliteInfo::setSignalStrength(int signalStrength )**

        Sets the signal strength to **signalStrength** , in decibels.

        **See also** **signalStrength** ().
        """
        ...

    def signalStrength(self) -> int:
        """
        **int QGeoSatelliteInfo::signalStrength() const**

        Returns the signal strength, or -1 if the value has not been set.

        **See also** **setSignalStrength** ().
        """
        ...
