"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets
import PySide2.QtPrintSupport

bytes = str


class QPrinterInfo(object):
    """
    **Detailed Description**

    Use the static functions to generate a list of QPrinterInfo objects. Each QPrinterInfo object in the list represents a single printer and can be queried for name, supported paper sizes, and whether or not it is the default printer.
    """

    @typing.overload
    def __init__(self) -> None:
        """
        **QPrinterInfo::QPrinterInfo()**

        Constructs an empty QPrinterInfo object.

        **See also** **isNull** ().
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtPrintSupport.QPrinterInfo) -> None:
        """
        **QPrinterInfo::QPrinterInfo()**

        Constructs an empty QPrinterInfo object.

        **See also** **isNull** ().
        """
        ...

    @typing.overload
    def __init__(self, printer: PySide2.QtPrintSupport.QPrinter) -> None:
        """
        **QPrinterInfo::QPrinterInfo()**

        Constructs an empty QPrinterInfo object.

        **See also** **isNull** ().
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    @staticmethod
    def availablePrinterNames() -> typing.List:
        """
        **[static] QStringList QPrinterInfo::availablePrinterNames()**

        Returns a list of all the available Printer Names on this system.

        It is recommended to use this instead of **availablePrinters** () as it will be faster on most systems.

        Note that the list may become outdated if changes are made on the local system or remote print server. Only instantiate required **QPrinterInfo**  instances when needed, and always check for validity before calling.

        This function was introduced in Qt 5.3.
        """
        ...

    @staticmethod
    def availablePrinters() -> typing.List:
        """
        **[static] QList<QPrinterInfo> QPrinterInfo::availablePrinters()**

        Returns a list of **QPrinterInfo**  objects for all the available printers on this system.

        It is NOT recommended to use this as creating each printer instance may take a long time, especially if there are remote networked printers, and retained instances may become outdated if changes are made on the local system or remote print server. Use **availablePrinterNames** () instead and only instantiate printer instances as you need them.
        """
        ...

    def defaultColorMode(self) -> PySide2.QtPrintSupport.QPrinter.ColorMode:
        """
        **QPrinter::ColorMode QPrinterInfo::defaultColorMode() const**

        Returns the default color mode of this printer.

        This function was introduced in Qt 5.13.
        """
        ...

    def defaultDuplexMode(self) -> PySide2.QtPrintSupport.QPrinter.DuplexMode:
        """
        **QPrinter::DuplexMode QPrinterInfo::defaultDuplexMode() const**

        Returns the default duplex mode of this printer.

        This function was introduced in Qt 5.4.
        """
        ...

    def defaultPageSize(self) -> PySide2.QtGui.QPageSize:
        """
        **QPageSize QPrinterInfo::defaultPageSize() const**

        Returns the current default Page Size for this printer.

        This function was introduced in Qt 5.3.
        """
        ...

    @staticmethod
    def defaultPrinter() -> PySide2.QtPrintSupport.QPrinterInfo:
        """
        **[static] QPrinterInfo QPrinterInfo::defaultPrinter()**

        Returns the default printer on the system.

        The return value should be checked using **isNull** () before being used, in case there is no default printer.

        On some systems it is possible for there to be available printers but none of them set to be the default printer.

        **See also** **isNull** (), **isDefault** (), and **availablePrinters** ().
        """
        ...

    @staticmethod
    def defaultPrinterName() -> str:
        """
        **[static] QString QPrinterInfo::defaultPrinterName()**

        Returns the current default printer name.

        This function was introduced in Qt 5.3.
        """
        ...

    def description(self) -> str:
        """
        **QString QPrinterInfo::description() const**

        Returns the human-readable description of the printer.

        This function was introduced in Qt 5.0.

        **See also** **QPrinterInfo::printerName** ().
        """
        ...

    def isDefault(self) -> bool:
        """
        **bool QPrinterInfo::isDefault() const**

        Returns whether this printer is currently the default printer.
        """
        ...

    def isNull(self) -> bool:
        """
        **bool QPrinterInfo::isNull() const**

        Returns whether this **QPrinterInfo**  object holds a printer definition.

        An empty **QPrinterInfo**  object could result for example from calling **defaultPrinter** () when there are no printers on the system.
        """
        ...

    def isRemote(self) -> bool:
        """
        **bool QPrinterInfo::isRemote() const**

        Returns whether this printer is a remote network printer.

        This function was introduced in Qt 5.3.
        """
        ...

    def location(self) -> str:
        """
        **QString QPrinterInfo::location() const**

        Returns the human-readable location of the printer.

        This function was introduced in Qt 5.0.
        """
        ...

    def makeAndModel(self) -> str:
        """
        **QString QPrinterInfo::makeAndModel() const**

        Returns the human-readable make and model of the printer.

        This function was introduced in Qt 5.0.
        """
        ...

    def maximumPhysicalPageSize(self) -> PySide2.QtGui.QPageSize:
        """
        **QPageSize QPrinterInfo::maximumPhysicalPageSize() const**

        Returns the maximum physical page size supported by this printer.

        This function was introduced in Qt 5.3.

        **See also** **minimumPhysicalPageSize** ().
        """
        ...

    def minimumPhysicalPageSize(self) -> PySide2.QtGui.QPageSize:
        """
        **QPageSize QPrinterInfo::minimumPhysicalPageSize() const**

        Returns the minimum physical page size supported by this printer.

        This function was introduced in Qt 5.3.

        **See also** **maximumPhysicalPageSize** ().
        """
        ...

    @staticmethod
    def printerInfo(printerName: str) -> PySide2.QtPrintSupport.QPrinterInfo:
        """
        **[static] QPrinterInfo QPrinterInfo::printerInfo(const QString & printerName )**

        Returns the printer **printerName**.

        The return value should be checked using **isNull** () before being used, in case the named printer does not exist.

        This function was introduced in Qt 5.0.

        **See also** **isNull** ().
        """
        ...

    def printerName(self) -> str:
        """
        **QString QPrinterInfo::printerName() const**

        Returns the name of the printer.

        This is a unique id to identify the printer and may not be human-readable.

        **See also** **QPrinterInfo::description** () and **QPrinter::setPrinterName** ().
        """
        ...

    def state(self) -> PySide2.QtPrintSupport.QPrinter.PrinterState:
        """
        **QPrinter::PrinterState QPrinterInfo::state() const**

        Returns the current state of this printer.

        This state may not always be accurate, depending on the platform, printer driver, or printer itself.

        This function was introduced in Qt 5.3.
        """
        ...

    def supportedColorModes(self) -> typing.List:
        """
        **QList<QPrinter::ColorMode> QPrinterInfo::supportedColorModes() const**

        Returns the supported color modes of this printer.

        This function was introduced in Qt 5.13.
        """
        ...

    def supportedDuplexModes(self) -> typing.List:
        """
        **QList<QPrinter::DuplexMode> QPrinterInfo::supportedDuplexModes() const**

        Returns a list of duplex modes supported by this printer.

        This function was introduced in Qt 5.4.
        """
        ...

    def supportedPageSizes(self) -> typing.List:
        """
        **QList<QPageSize> QPrinterInfo::supportedPageSizes() const**

        Returns a list of Page Sizes supported by this printer.

        This function was introduced in Qt 5.3.
        """
        ...

    def supportedPaperSizes(self) -> typing.List:
        ...

    def supportedResolutions(self) -> typing.List:
        """
        **QList<int> QPrinterInfo::supportedResolutions() const**

        Returns a list of resolutions supported by this printer.

        This function was introduced in Qt 5.3.
        """
        ...

    def supportedSizesWithNames(self) -> typing.List:
        ...

    def supportsCustomPageSizes(self) -> bool:
        """
        **bool QPrinterInfo::supportsCustomPageSizes() const**

        Returns whether this printer supports custom page sizes.

        This function was introduced in Qt 5.3.
        """
        ...
