"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets

bytes = str


class QGraphicsSceneContextMenuEvent(PySide2.QtWidgets.QGraphicsSceneEvent):
    """
    **Detailed Description**

    A **QContextMenuEvent**  received by a **QGraphicsView**  is translated into a QGraphicsSceneContextMenuEvent. The **QContextMenuEvent::globalPos** () is translated into item, scene, and screen coordinates (**pos** (), **scenePos** (), and **screenPos** ()).

    **See also** **QGraphicsSceneMouseEvent** , **QGraphicsSceneWheelEvent** , and **QContextMenuEvent** .
    """

    Mouse: QGraphicsSceneContextMenuEvent = ...
    Keyboard: QGraphicsSceneContextMenuEvent = ...
    Other: QGraphicsSceneContextMenuEvent = ...

    class Reason(object):
        Mouse: QGraphicsSceneContextMenuEvent.Reason = ...
        Keyboard: QGraphicsSceneContextMenuEvent.Reason = ...
        Other: QGraphicsSceneContextMenuEvent.Reason = ...

    def __init__(self, type: typing.Optional[PySide2.QtCore.QEvent.Type] = ...) -> None:
        ...

    def modifiers(self) -> PySide2.QtCore.Qt.KeyboardModifiers:
        """
        **Qt::KeyboardModifiers QGraphicsSceneContextMenuEvent::modifiers() const**

        Returns the keyboard modifiers in use when the context menu was requested.
        """
        ...

    def pos(self) -> PySide2.QtCore.QPointF:
        """
        **QPointF QGraphicsSceneContextMenuEvent::pos() const**

        Returns the position of the mouse cursor in item coordinates at the moment the context menu was requested.

        **See also** **scenePos** () and **screenPos** ().
        """
        ...

    def reason(self) -> PySide2.QtWidgets.QGraphicsSceneContextMenuEvent.Reason:
        """
        **QGraphicsSceneContextMenuEvent::Reason QGraphicsSceneContextMenuEvent::reason() const**

        Returns the reason for the context menu event.

        **See also** **QGraphicsSceneContextMenuEvent::Reason** .
        """
        ...

    def scenePos(self) -> PySide2.QtCore.QPointF:
        """
        **QPointF QGraphicsSceneContextMenuEvent::scenePos() const**

        Returns the position of the mouse cursor in scene coordinates at the moment the context menu was requested.

        **See also** **pos** () and **screenPos** ().
        """
        ...

    def screenPos(self) -> PySide2.QtCore.QPoint:
        """
        **QPoint QGraphicsSceneContextMenuEvent::screenPos() const**

        Returns the position of the mouse cursor in screen coordinates at the moment the context menu was requested.

        **See also** **pos** () and **scenePos** ().
        """
        ...

    def setModifiers(self, modifiers: PySide2.QtCore.Qt.KeyboardModifiers) -> None:
        """
        **Qt::KeyboardModifiers QGraphicsSceneContextMenuEvent::modifiers() const**

        Returns the keyboard modifiers in use when the context menu was requested.
        """
        ...

    def setPos(self, pos: PySide2.QtCore.QPointF) -> None:
        """
        **QPointF QGraphicsSceneContextMenuEvent::pos() const**

        Returns the position of the mouse cursor in item coordinates at the moment the context menu was requested.

        **See also** **scenePos** () and **screenPos** ().
        """
        ...

    def setReason(
        self, reason: PySide2.QtWidgets.QGraphicsSceneContextMenuEvent.Reason
    ) -> None:
        """
        **QGraphicsSceneContextMenuEvent::Reason QGraphicsSceneContextMenuEvent::reason() const**

        Returns the reason for the context menu event.

        **See also** **QGraphicsSceneContextMenuEvent::Reason** .
        """
        ...

    def setScenePos(self, pos: PySide2.QtCore.QPointF) -> None:
        """
        **QPointF QGraphicsSceneContextMenuEvent::scenePos() const**

        Returns the position of the mouse cursor in scene coordinates at the moment the context menu was requested.

        **See also** **pos** () and **screenPos** ().
        """
        ...

    def setScreenPos(self, pos: PySide2.QtCore.QPoint) -> None:
        """
        **QPoint QGraphicsSceneContextMenuEvent::screenPos() const**

        Returns the position of the mouse cursor in screen coordinates at the moment the context menu was requested.

        **See also** **pos** () and **scenePos** ().
        """
        ...
