"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets

bytes = str


class QGraphicsSceneHoverEvent(PySide2.QtWidgets.QGraphicsSceneEvent):
    """
    **Detailed Description**

    When a **QGraphicsView**  receives a **QHoverEvent**  event, it translates it into QGraphicsSceneHoverEvent. The event is then forwarded to the **QGraphicsScene**  associated with the view.

    **See also** **QGraphicsSceneMouseEvent** , **QGraphicsSceneContextMenuEvent** , **QGraphicsSceneWheelEvent** , and **QHoverEvent** .
    """

    def __init__(self, type: typing.Optional[PySide2.QtCore.QEvent.Type] = ...) -> None:
        ...

    def lastPos(self) -> PySide2.QtCore.QPointF:
        """
        **QPointF QGraphicsSceneHoverEvent::lastPos() const**

        Returns the last recorded mouse cursor position in item coordinates.

        This function was introduced in Qt 4.4.

        **See also** **lastScenePos** (), **lastScreenPos** (), and **pos** ().
        """
        ...

    def lastScenePos(self) -> PySide2.QtCore.QPointF:
        """
        **QPointF QGraphicsSceneHoverEvent::lastScenePos() const**

        Returns the last recorded, the scene coordinates of the previous mouse or hover event received by the view, that created the event mouse cursor position in scene coordinates.

        This function was introduced in Qt 4.4.

        **See also** **lastPos** (), **lastScreenPos** (), and **scenePos** ().
        """
        ...

    def lastScreenPos(self) -> PySide2.QtCore.QPoint:
        """
        **QPoint QGraphicsSceneHoverEvent::lastScreenPos() const**

        Returns the last recorded mouse cursor position in screen coordinates. The last recorded position is the position of the previous mouse or hover event received by the view that created the event.

        This function was introduced in Qt 4.4.

        **See also** **lastPos** (), **lastScenePos** (), and **screenPos** ().
        """
        ...

    def modifiers(self) -> PySide2.QtCore.Qt.KeyboardModifiers:
        """
        **Qt::KeyboardModifiers QGraphicsSceneHoverEvent::modifiers() const**

        Returns the keyboard modifiers at the moment the hover event was sent.

        This function was introduced in Qt 4.4.
        """
        ...

    def pos(self) -> PySide2.QtCore.QPointF:
        """
        **QPointF QGraphicsSceneHoverEvent::pos() const**

        Returns the position of the mouse cursor in item coordinates at the moment the hover event was sent.

        **See also** **scenePos** () and **screenPos** ().
        """
        ...

    def scenePos(self) -> PySide2.QtCore.QPointF:
        """
        **QPointF QGraphicsSceneHoverEvent::scenePos() const**

        Returns the position of the mouse cursor in scene coordinates at the moment the hover event was sent.

        **See also** **pos** () and **screenPos** ().
        """
        ...

    def screenPos(self) -> PySide2.QtCore.QPoint:
        """
        **QPoint QGraphicsSceneHoverEvent::screenPos() const**

        Returns the position of the mouse cursor in screen coordinates at the moment the hover event was sent.

        **See also** **pos** () and **scenePos** ().
        """
        ...

    def setLastPos(self, pos: PySide2.QtCore.QPointF) -> None:
        """
        **QPointF QGraphicsSceneHoverEvent::lastPos() const**

        Returns the last recorded mouse cursor position in item coordinates.

        This function was introduced in Qt 4.4.

        **See also** **lastScenePos** (), **lastScreenPos** (), and **pos** ().
        """
        ...

    def setLastScenePos(self, pos: PySide2.QtCore.QPointF) -> None:
        """
        **QPointF QGraphicsSceneHoverEvent::lastScenePos() const**

        Returns the last recorded, the scene coordinates of the previous mouse or hover event received by the view, that created the event mouse cursor position in scene coordinates.

        This function was introduced in Qt 4.4.

        **See also** **lastPos** (), **lastScreenPos** (), and **scenePos** ().
        """
        ...

    def setLastScreenPos(self, pos: PySide2.QtCore.QPoint) -> None:
        """
        **QPoint QGraphicsSceneHoverEvent::lastScreenPos() const**

        Returns the last recorded mouse cursor position in screen coordinates. The last recorded position is the position of the previous mouse or hover event received by the view that created the event.

        This function was introduced in Qt 4.4.

        **See also** **lastPos** (), **lastScenePos** (), and **screenPos** ().
        """
        ...

    def setModifiers(self, modifiers: PySide2.QtCore.Qt.KeyboardModifiers) -> None:
        """
        **Qt::KeyboardModifiers QGraphicsSceneHoverEvent::modifiers() const**

        Returns the keyboard modifiers at the moment the hover event was sent.

        This function was introduced in Qt 4.4.
        """
        ...

    def setPos(self, pos: PySide2.QtCore.QPointF) -> None:
        """
        **QPointF QGraphicsSceneHoverEvent::pos() const**

        Returns the position of the mouse cursor in item coordinates at the moment the hover event was sent.

        **See also** **scenePos** () and **screenPos** ().
        """
        ...

    def setScenePos(self, pos: PySide2.QtCore.QPointF) -> None:
        """
        **QPointF QGraphicsSceneHoverEvent::scenePos() const**

        Returns the position of the mouse cursor in scene coordinates at the moment the hover event was sent.

        **See also** **pos** () and **screenPos** ().
        """
        ...

    def setScreenPos(self, pos: PySide2.QtCore.QPoint) -> None:
        """
        **QPoint QGraphicsSceneHoverEvent::screenPos() const**

        Returns the position of the mouse cursor in screen coordinates at the moment the hover event was sent.

        **See also** **pos** () and **scenePos** ().
        """
        ...
