"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets

bytes = str


class QGraphicsSceneMouseEvent(PySide2.QtWidgets.QGraphicsSceneEvent):
    """
    **Detailed Description**

    When a **QGraphicsView**  receives a **QMouseEvent** , it translates it to a QGraphicsSceneMouseEvent. The event is then forwarded to the **QGraphicsScene**  associated with the view. If the event is not handled by the scene, the view may use it, e.g., for the **DragMode** .

    In addition to containing the item, scene, and screen coordinates of the event (as **pos** (), **scenePos** (), and **screenPos** ()), mouse events also contain the coordinates of the previous mouse event received by the view. These can be retrieved with **lastPos** (), **lastScreenPos** (), and **lastScenePos** ().

    **See also** **QGraphicsSceneContextMenuEvent** , **QGraphicsSceneHoverEvent** , **QGraphicsSceneWheelEvent** , and **QMouseEvent** .
    """

    def __init__(self, type: typing.Optional[PySide2.QtCore.QEvent.Type] = ...) -> None:
        ...

    def button(self) -> PySide2.QtCore.Qt.MouseButton:
        """
        **Qt::MouseButton QGraphicsSceneMouseEvent::button() const**

        Returns the mouse button (if any) that caused the event.

        **See also** **buttons** () and **modifiers** ().
        """
        ...

    def buttonDownPos(
        self, button: PySide2.QtCore.Qt.MouseButton
    ) -> PySide2.QtCore.QPointF:
        """
        **QPointF QGraphicsSceneMouseEvent::buttonDownPos(Qt::MouseButton button ) const**

        Returns the mouse cursor position in item coordinates where the specified **button** was clicked.

        **See also** **buttonDownScenePos** (), **buttonDownScreenPos** (), and **pos** ().
        """
        ...

    def buttonDownScenePos(
        self, button: PySide2.QtCore.Qt.MouseButton
    ) -> PySide2.QtCore.QPointF:
        """
        **QPointF QGraphicsSceneMouseEvent::buttonDownScenePos(Qt::MouseButton button ) const**

        Returns the mouse cursor position in scene coordinates where the specified **button** was clicked.

        **See also** **buttonDownPos** (), **buttonDownScreenPos** (), and **scenePos** ().
        """
        ...

    def buttonDownScreenPos(
        self, button: PySide2.QtCore.Qt.MouseButton
    ) -> PySide2.QtCore.QPoint:
        """
        **QPoint QGraphicsSceneMouseEvent::buttonDownScreenPos(Qt::MouseButton button ) const**

        Returns the mouse cursor position in screen coordinates where the specified **button** was clicked.

        **See also** **screenPos** (), **buttonDownPos** (), and **buttonDownScenePos** ().
        """
        ...

    def buttons(self) -> PySide2.QtCore.Qt.MouseButtons:
        """
        **Qt::MouseButtons QGraphicsSceneMouseEvent::buttons() const**

        Returns the combination of mouse buttons that were pressed at the time the event was sent.

        **See also** **button** () and **modifiers** ().
        """
        ...

    def flags(self) -> PySide2.QtCore.Qt.MouseEventFlags:
        """
        **Qt::MouseEventFlags QGraphicsSceneMouseEvent::flags() const**

        Returns the mouse event flags.

        The mouse event flags provide additional information about a mouse event.

        This function was introduced in Qt 5.4.

        **See also** **Qt::MouseEventFlag**  and **QMouseEvent::flags** ().
        """
        ...

    def lastPos(self) -> PySide2.QtCore.QPointF:
        """
        **QPointF QGraphicsSceneMouseEvent::lastPos() const**

        Returns the last recorded mouse cursor position in item coordinates.

        **See also** **lastScenePos** (), **lastScreenPos** (), and **pos** ().
        """
        ...

    def lastScenePos(self) -> PySide2.QtCore.QPointF:
        """
        **QPointF QGraphicsSceneMouseEvent::lastScenePos() const**

        Returns the last recorded mouse cursor position in scene coordinates. The last recorded position is the position of the previous mouse event received by the view that created the event.

        **See also** **lastPos** (), **lastScreenPos** (), and **scenePos** ().
        """
        ...

    def lastScreenPos(self) -> PySide2.QtCore.QPoint:
        """
        **QPoint QGraphicsSceneMouseEvent::lastScreenPos() const**

        Returns the last recorded mouse cursor position in screen coordinates. The last recorded position is the position of the previous mouse event received by the view that created the event.

        **See also** **lastPos** (), **lastScenePos** (), and **screenPos** ().
        """
        ...

    def modifiers(self) -> PySide2.QtCore.Qt.KeyboardModifiers:
        """
        **Qt::KeyboardModifiers QGraphicsSceneMouseEvent::modifiers() const**

        Returns the keyboard modifiers in use at the time the event was sent.

        **See also** **buttons** () and **button** ().
        """
        ...

    def pos(self) -> PySide2.QtCore.QPointF:
        """
        **QPointF QGraphicsSceneMouseEvent::pos() const**

        Returns the mouse cursor position in item coordinates.

        **See also** **scenePos** (), **screenPos** (), and **lastPos** ().
        """
        ...

    def scenePos(self) -> PySide2.QtCore.QPointF:
        """
        **QPointF QGraphicsSceneMouseEvent::scenePos() const**

        Returns the mouse cursor position in scene coordinates.

        **See also** **pos** (), **screenPos** (), and **lastScenePos** ().
        """
        ...

    def screenPos(self) -> PySide2.QtCore.QPoint:
        """
        **QPoint QGraphicsSceneMouseEvent::screenPos() const**

        Returns the mouse cursor position in screen coordinates.

        **See also** **pos** (), **scenePos** (), and **lastScreenPos** ().
        """
        ...

    def setButton(self, button: PySide2.QtCore.Qt.MouseButton) -> None:
        """
        **Qt::MouseButton QGraphicsSceneMouseEvent::button() const**

        Returns the mouse button (if any) that caused the event.

        **See also** **buttons** () and **modifiers** ().
        """
        ...

    def setButtonDownPos(
        self, button: PySide2.QtCore.Qt.MouseButton, pos: PySide2.QtCore.QPointF
    ) -> None:
        """
        **QPointF QGraphicsSceneMouseEvent::buttonDownPos(Qt::MouseButton button ) const**

        Returns the mouse cursor position in item coordinates where the specified **button** was clicked.

        **See also** **buttonDownScenePos** (), **buttonDownScreenPos** (), and **pos** ().
        """
        ...

    def setButtonDownScenePos(
        self, button: PySide2.QtCore.Qt.MouseButton, pos: PySide2.QtCore.QPointF
    ) -> None:
        """
        **QPointF QGraphicsSceneMouseEvent::buttonDownScenePos(Qt::MouseButton button ) const**

        Returns the mouse cursor position in scene coordinates where the specified **button** was clicked.

        **See also** **buttonDownPos** (), **buttonDownScreenPos** (), and **scenePos** ().
        """
        ...

    def setButtonDownScreenPos(
        self, button: PySide2.QtCore.Qt.MouseButton, pos: PySide2.QtCore.QPoint
    ) -> None:
        """
        **QPoint QGraphicsSceneMouseEvent::buttonDownScreenPos(Qt::MouseButton button ) const**

        Returns the mouse cursor position in screen coordinates where the specified **button** was clicked.

        **See also** **screenPos** (), **buttonDownPos** (), and **buttonDownScenePos** ().
        """
        ...

    def setButtons(self, buttons: PySide2.QtCore.Qt.MouseButtons) -> None:
        """
        **Qt::MouseButtons QGraphicsSceneMouseEvent::buttons() const**

        Returns the combination of mouse buttons that were pressed at the time the event was sent.

        **See also** **button** () and **modifiers** ().
        """
        ...

    def setFlags(self, arg__1: PySide2.QtCore.Qt.MouseEventFlags) -> None:
        """
        **Qt::MouseEventFlags QGraphicsSceneMouseEvent::flags() const**

        Returns the mouse event flags.

        The mouse event flags provide additional information about a mouse event.

        This function was introduced in Qt 5.4.

        **See also** **Qt::MouseEventFlag**  and **QMouseEvent::flags** ().
        """
        ...

    def setLastPos(self, pos: PySide2.QtCore.QPointF) -> None:
        """
        **QPointF QGraphicsSceneMouseEvent::lastPos() const**

        Returns the last recorded mouse cursor position in item coordinates.

        **See also** **lastScenePos** (), **lastScreenPos** (), and **pos** ().
        """
        ...

    def setLastScenePos(self, pos: PySide2.QtCore.QPointF) -> None:
        """
        **QPointF QGraphicsSceneMouseEvent::lastScenePos() const**

        Returns the last recorded mouse cursor position in scene coordinates. The last recorded position is the position of the previous mouse event received by the view that created the event.

        **See also** **lastPos** (), **lastScreenPos** (), and **scenePos** ().
        """
        ...

    def setLastScreenPos(self, pos: PySide2.QtCore.QPoint) -> None:
        """
        **QPoint QGraphicsSceneMouseEvent::lastScreenPos() const**

        Returns the last recorded mouse cursor position in screen coordinates. The last recorded position is the position of the previous mouse event received by the view that created the event.

        **See also** **lastPos** (), **lastScenePos** (), and **screenPos** ().
        """
        ...

    def setModifiers(self, modifiers: PySide2.QtCore.Qt.KeyboardModifiers) -> None:
        """
        **Qt::KeyboardModifiers QGraphicsSceneMouseEvent::modifiers() const**

        Returns the keyboard modifiers in use at the time the event was sent.

        **See also** **buttons** () and **button** ().
        """
        ...

    def setPos(self, pos: PySide2.QtCore.QPointF) -> None:
        """
        **QPointF QGraphicsSceneMouseEvent::pos() const**

        Returns the mouse cursor position in item coordinates.

        **See also** **scenePos** (), **screenPos** (), and **lastPos** ().
        """
        ...

    def setScenePos(self, pos: PySide2.QtCore.QPointF) -> None:
        """
        **QPointF QGraphicsSceneMouseEvent::scenePos() const**

        Returns the mouse cursor position in scene coordinates.

        **See also** **pos** (), **screenPos** (), and **lastScenePos** ().
        """
        ...

    def setScreenPos(self, pos: PySide2.QtCore.QPoint) -> None:
        """
        **QPoint QGraphicsSceneMouseEvent::screenPos() const**

        Returns the mouse cursor position in screen coordinates.

        **See also** **pos** (), **scenePos** (), and **lastScreenPos** ().
        """
        ...

    def setSource(self, source: PySide2.QtCore.Qt.MouseEventSource) -> None:
        """
        **Qt::MouseEventSource QGraphicsSceneMouseEvent::source() const**

        Returns information about the mouse event source.

        The mouse event source can be used to distinguish between genuine and artificial mouse events. The latter are events that are synthesized from touch events by the operating system or Qt itself.

        This function was introduced in Qt 5.4.

        **See also** **Qt::MouseEventSource**  and **QMouseEvent::source** ().
        """
        ...

    def source(self) -> PySide2.QtCore.Qt.MouseEventSource:
        """
        **Qt::MouseEventSource QGraphicsSceneMouseEvent::source() const**

        Returns information about the mouse event source.

        The mouse event source can be used to distinguish between genuine and artificial mouse events. The latter are events that are synthesized from touch events by the operating system or Qt itself.

        This function was introduced in Qt 5.4.

        **See also** **Qt::MouseEventSource**  and **QMouseEvent::source** ().
        """
        ...
