"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets

bytes = str


class QPlainTextDocumentLayout(PySide2.QtGui.QAbstractTextDocumentLayout):
    """
    **Detailed Description**

    A QPlainTextDocumentLayout is required for text documents that can be display or edited in a **QPlainTextEdit** . See **QTextDocument::setDocumentLayout** ().

    QPlainTextDocumentLayout uses the **QAbstractTextDocumentLayout**  API that **QTextDocument**  requires, but redefines it partially in order to support plain text better. For instances, it does not operate on vertical pixels, but on paragraphs (called blocks) instead. The height of a document is identical to the number of paragraphs it contains. The layout also doesn't support tables or nested frames, or any sort of advanced text layout that goes beyond a list of paragraphs with syntax highlighting.
    """

    def __init__(self, document: PySide2.QtGui.QTextDocument) -> None:
        """
        **QPlainTextDocumentLayout::QPlainTextDocumentLayout(QTextDocument * document )**

        Constructs a plain text document layout for the text **document**.
        """
        ...

    def blockBoundingRect(
        self, block: PySide2.QtGui.QTextBlock
    ) -> PySide2.QtCore.QRectF:
        """
        **[override virtual] QRectF QPlainTextDocumentLayout::blockBoundingRect(const QTextBlock & block ) const**

        Reimplements: **QAbstractTextDocumentLayout::blockBoundingRect** (const QTextBlock &block) const.
        """
        ...

    def cursorWidth(self) -> int:
        """
        **cursorWidth : int**

        This property specifies the width of the cursor in pixels. The default value is 1.

        **Access functions:**

        int **cursorWidth** () const
        void **setCursorWidth** (int **width** )

        **Member Function Documentation**
        """
        ...

    def documentChanged(self, from_: int, arg__2: int, charsAdded: int) -> None:
        """
        **[override virtual protected] void QPlainTextDocumentLayout::documentChanged(int from , int charsRemoved , int charsAdded )**

        Reimplements: **QAbstractTextDocumentLayout::documentChanged** (int position, int charsRemoved, int charsAdded).
        """
        ...

    def documentSize(self) -> PySide2.QtCore.QSizeF:
        """
        **[override virtual] QSizeF QPlainTextDocumentLayout::documentSize() const**

        Reimplements: **QAbstractTextDocumentLayout::documentSize** () const.
        """
        ...

    def draw(
        self,
        arg__1: PySide2.QtGui.QPainter,
        arg__2: PySide2.QtGui.QAbstractTextDocumentLayout.PaintContext,
    ) -> None:
        """
        **[override virtual] void QPlainTextDocumentLayout::draw( QPainter * , const QAbstractTextDocumentLayout::PaintContext &)**

        Reimplements: **QAbstractTextDocumentLayout::draw** (QPainter *painter, const QAbstractTextDocumentLayout::PaintContext &context).
        """
        ...

    def ensureBlockLayout(self, block: PySide2.QtGui.QTextBlock) -> None:
        """
        **void QPlainTextDocumentLayout::ensureBlockLayout(const QTextBlock & block ) const**

        Ensures that **block** has a valid layout
        """
        ...

    def frameBoundingRect(
        self, arg__1: PySide2.QtGui.QTextFrame
    ) -> PySide2.QtCore.QRectF:
        """
        **[override virtual] QRectF QPlainTextDocumentLayout::frameBoundingRect( QTextFrame * ) const**

        Reimplements: **QAbstractTextDocumentLayout::frameBoundingRect** (QTextFrame *frame) const.
        """
        ...

    def hitTest(
        self, arg__1: PySide2.QtCore.QPointF, arg__2: PySide2.QtCore.Qt.HitTestAccuracy
    ) -> int:
        """
        **[override virtual] int QPlainTextDocumentLayout::hitTest( const QPointF &, Qt::HitTestAccuracy ) const**

        Reimplements: **QAbstractTextDocumentLayout::hitTest** (const QPointF &point, Qt::HitTestAccuracy accuracy) const.
        """
        ...

    def pageCount(self) -> int:
        """
        **[override virtual] int QPlainTextDocumentLayout::pageCount() const**

        Reimplements: **QAbstractTextDocumentLayout::pageCount** () const.
        """
        ...

    def requestUpdate(self) -> None:
        """
        **void QPlainTextDocumentLayout::requestUpdate()**

        Requests a complete update on all views.
        """
        ...

    def setCursorWidth(self, width: int) -> None:
        """
        **cursorWidth : int**

        This property specifies the width of the cursor in pixels. The default value is 1.

        **Access functions:**

        int **cursorWidth** () const
        void **setCursorWidth** (int **width** )

        **Member Function Documentation**
        """
        ...
