"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets

bytes = str


class QTableWidgetSelectionRange(object):
    """
    **Detailed Description**

    The QTableWidgetSelectionRange class stores the top left and bottom right rows and columns of a selection range in a table. The selections in the table may consist of several selection ranges.

    **Note:** If the item within the selection range is marked as not selectable, e.g., `itemFlags() & Qt::ItemIsSelectable == 0` then it will not appear in the selection range.

    **See also** **QTableWidget** .
    """

    @typing.overload
    def __init__(self) -> None:
        """
        **QTableWidgetSelectionRange::QTableWidgetSelectionRange()**

        Constructs an table selection range, i.e. a range whose **rowCount** () and **columnCount** () are 0.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtWidgets.QTableWidgetSelectionRange) -> None:
        """
        **QTableWidgetSelectionRange::QTableWidgetSelectionRange()**

        Constructs an table selection range, i.e. a range whose **rowCount** () and **columnCount** () are 0.
        """
        ...

    @typing.overload
    def __init__(self, top: int, left: int, bottom: int, right: int) -> None:
        """
        **QTableWidgetSelectionRange::QTableWidgetSelectionRange()**

        Constructs an table selection range, i.e. a range whose **rowCount** () and **columnCount** () are 0.
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    def bottomRow(self) -> int:
        """
        **int QTableWidgetSelectionRange::bottomRow() const**

        Returns the bottom row of the range.

        **See also** **topRow** (), **rightColumn** (), and **rowCount** ().
        """
        ...

    def columnCount(self) -> int:
        """
        **int QTableWidgetSelectionRange::columnCount() const**

        Returns the number of columns in the range.

        This is equivalent to **rightColumn** () - **leftColumn** () + 1.

        This function was introduced in Qt 4.1.

        **See also** **rowCount** (), **leftColumn** (), and **rightColumn** ().
        """
        ...

    def leftColumn(self) -> int:
        """
        **int QTableWidgetSelectionRange::leftColumn() const**

        Returns the left column of the range.

        **See also** **rightColumn** (), **topRow** (), and **columnCount** ().
        """
        ...

    def rightColumn(self) -> int:
        """
        **int QTableWidgetSelectionRange::rightColumn() const**

        Returns the right column of the range.

        **See also** **leftColumn** (), **bottomRow** (), and **columnCount** ().
        """
        ...

    def rowCount(self) -> int:
        """
        **int QTableWidgetSelectionRange::rowCount() const**

        Returns the number of rows in the range.

        This is equivalent to **bottomRow** () - **topRow** () + 1.

        This function was introduced in Qt 4.1.

        **See also** **columnCount** (), **topRow** (), and **bottomRow** ().
        """
        ...

    def topRow(self) -> int:
        """
        **int QTableWidgetSelectionRange::topRow() const**

        Returns the top row of the range.

        **See also** **bottomRow** (), **leftColumn** (), and **rowCount** ().
        """
        ...
