"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets
import PySide2.QtWinExtras

bytes = str


class QWinTaskbarButton(PySide2.QtCore.QObject):
    """
    **Detailed Description**

    The QWinTaskbarButton class enables you to set overlay icons on a taskbar button, and provides access to its progress indicator.

    An overlay icon indicates change in the state of an application, whereas a progress indicator shows how time-consuming tasks are progressing.

    ![Taskbar Button](images/taskbar-button.png)

    The following example code illustrates how to use the QWinTaskbarButton and **QWinTaskbarProgress**  classes to adjust the look of the taskbar button:

    **QWinTaskbarButton**  *button = new **QWinTaskbarButton** (widget);
            button->setWindow(widget->windowHandle());
            button->setOverlayIcon(**QIcon** (":/loading.png"));

            **QWinTaskbarProgress**  *progress = button->progress();
            progress->setVisible(true);
            progress->setValue(50);

    **Note:****QWidget::windowHandle** () returns a valid instance of a **QWindow**  only after the widget has been shown. It is therefore recommended to delay the initialization of the QWinTaskbarButton instances until **QWidget::showEvent** ().

    **Note:** The class wraps API only available since Windows 7. Instantiating it on Windows XP or Windows Vista causes a runtime warning.

    **See also** **QWinTaskbarProgress** .
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        **QWinTaskbarButton::QWinTaskbarButton(QObject * parent = nullptr)**

        Constructs a QWinTaskbarButton with the specified **parent**.

        If **parent** is an instance of **QWindow** , it is automatically assigned as the taskbar button's **window** .
        """
        ...

    def clearOverlayIcon(self) -> None:
        ...

    def eventFilter(
        self, arg__1: PySide2.QtCore.QObject, arg__2: PySide2.QtCore.QEvent
    ) -> bool:
        ...

    def overlayAccessibleDescription(self) -> str:
        """
        **overlayAccessibleDescription : QString**

        This property holds the description of the overlay for accessibility purposes

        **Access functions:**

        QString **overlayAccessibleDescription** () const
        void **setOverlayAccessibleDescription** (const QString & **description** )

        **See also** **overlayIcon** .
        """
        ...

    def overlayIcon(self) -> PySide2.QtGui.QIcon:
        """
        **overlayIcon : QIcon**

        This property holds the overlay icon of the taskbar button

        **Access functions:**

        QIcon **overlayIcon** () const
        void **setOverlayIcon** (const QIcon & **icon** )
        void **clearOverlayIcon** ()
        """
        ...

    def progress(self) -> PySide2.QtWinExtras.QWinTaskbarProgress:
        """
        **progress : QWinTaskbarProgress* const**

        This property holds the progress indicator of the taskbar button

        **Note:** The progress indicator is not **visible**  by default.

        **Access functions:**

        QWinTaskbarProgress * **progress** () const
        """
        ...

    def setOverlayAccessibleDescription(self, description: str) -> None:
        """
        **overlayAccessibleDescription : QString**

        This property holds the description of the overlay for accessibility purposes

        **Access functions:**

        QString **overlayAccessibleDescription** () const
        void **setOverlayAccessibleDescription** (const QString & **description** )

        **See also** **overlayIcon** .
        """
        ...

    def setOverlayIcon(self, icon: PySide2.QtGui.QIcon) -> None:
        """
        **overlayIcon : QIcon**

        This property holds the overlay icon of the taskbar button

        **Access functions:**

        QIcon **overlayIcon** () const
        void **setOverlayIcon** (const QIcon & **icon** )
        void **clearOverlayIcon** ()
        """
        ...

    def setWindow(self, window: PySide2.QtGui.QWindow) -> None:
        """
        **window : QWindow***

        This property holds the window whose taskbar button is manipulated

        **Access functions:**

        QWindow * **window** () const
        void **setWindow** (QWindow * **window** )

        **Member Function Documentation**
        """
        ...

    def window(self) -> PySide2.QtGui.QWindow:
        """
        **window : QWindow***

        This property holds the window whose taskbar button is manipulated

        **Access functions:**

        QWindow * **window** () const
        void **setWindow** (QWindow * **window** )

        **Member Function Documentation**
        """
        ...
