"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtXml

bytes = str


class QDomCharacterData(PySide2.QtXml.QDomNode):
    """
    **Detailed Description**

    Character data as used in XML specifies a generic data string. More specialized versions of this class are **QDomText** , **QDomComment**  and **QDomCDATASection** .

    The data string is set with **setData** () and retrieved with **data** (). You can retrieve a portion of the data string using **substringData** (). Extra data can be appended with **appendData** (), or inserted with **insertData** (). Portions of the data string can be deleted with **deleteData** () or replaced with **replaceData** (). The length of the data string is returned by **length** ().

    The node type of the node containing this character data is returned by **nodeType** ().

    **See also** **QDomText** , **QDomComment** , and **QDomCDATASection** .
    """

    @typing.overload
    def __init__(self) -> None:
        """
        **QDomCharacterData::QDomCharacterData()**

        Constructs an empty character data object.
        """
        ...

    @typing.overload
    def __init__(self, x: PySide2.QtXml.QDomCharacterData) -> None:
        """
        **QDomCharacterData::QDomCharacterData()**

        Constructs an empty character data object.
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    def appendData(self, arg: str) -> None:
        """
        **void QDomCharacterData::appendData(const QString & arg )**

        Appends the string **arg** to the stored string.
        """
        ...

    def data(self) -> str:
        """
        **QString QDomCharacterData::data() const**

        Returns the string stored in this object.

        If the node is a **null node** , it will return an empty string.

        **See also** **setData** ().
        """
        ...

    def deleteData(self, offset: int, count: int) -> None:
        """
        **void QDomCharacterData::deleteData(unsigned long offset , unsigned long count )**

        Deletes a substring of length **count** from position **offset**.
        """
        ...

    def insertData(self, offset: int, arg: str) -> None:
        """
        **void QDomCharacterData::insertData(unsigned long offset , const QString & arg )**

        Inserts the string **arg** into the stored string at position **offset**.
        """
        ...

    def length(self) -> int:
        """
        **int QDomCharacterData::length() const**

        Returns the length of the stored string.
        """
        ...

    def nodeType(self) -> PySide2.QtXml.QDomNode.NodeType:
        """
        **QDomNode::NodeType QDomCharacterData::nodeType() const**

        Returns the type of node this object refers to (i.e. `TextNode`, `CDATASectionNode`, `CommentNode` or `CharacterDataNode`). For a **null node** , returns `CharacterDataNode`.
        """
        ...

    def replaceData(self, offset: int, count: int, arg: str) -> None:
        """
        **void QDomCharacterData::replaceData(unsigned long offset , unsigned long count , const QString & arg )**

        Replaces the substring of length **count** starting at position **offset** with the string **arg**.
        """
        ...

    def setData(self, arg__1: str) -> None:
        """
        **void QDomCharacterData::setData(const QString & v )**

        Sets this object's string to **v**.

        **See also** **data** ().
        """
        ...

    def substringData(self, offset: int, count: int) -> str:
        """
        **QString QDomCharacterData::substringData(unsigned long offset , unsigned long count )**

        Returns the substring of length **count** from position **offset**.
        """
        ...
