"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtXml

bytes = str


class QDomDocumentType(PySide2.QtXml.QDomNode):
    """
    **Detailed Description**

    The QDomDocumentType class allows read-only access to some of the data structures in the DTD: it can return a map of all **entities** () and **notations** (). In addition the function **name** () returns the name of the document type as specified in the &lt;!DOCTYPE name&gt; tag. This class also provides the **publicId** (), **systemId** () and **internalSubset** () functions.

    **See also** **QDomDocument** .
    """

    @typing.overload
    def __init__(self) -> None:
        """
        **QDomDocumentType::QDomDocumentType()**

        Creates an empty QDomDocumentType object.
        """
        ...

    @typing.overload
    def __init__(self, x: PySide2.QtXml.QDomDocumentType) -> None:
        """
        **QDomDocumentType::QDomDocumentType()**

        Creates an empty QDomDocumentType object.
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    def entities(self) -> PySide2.QtXml.QDomNamedNodeMap:
        """
        **QDomNamedNodeMap QDomDocumentType::entities() const**

        Returns a map of all entities described in the DTD.
        """
        ...

    def internalSubset(self) -> str:
        """
        **QString QDomDocumentType::internalSubset() const**

        Returns the internal subset of the document type or an empty string if there is no internal subset.

        **See also** **publicId** () and **systemId** ().
        """
        ...

    def name(self) -> str:
        """
        **QString QDomDocumentType::name() const**

        Returns the name of the document type as specified in the &lt;!DOCTYPE name&gt; tag.

        **See also** **nodeName** ().
        """
        ...

    def nodeType(self) -> PySide2.QtXml.QDomNode.NodeType:
        """
        **QDomNode::NodeType QDomDocumentType::nodeType() const**

        Returns `DocumentTypeNode`.

        **See also** **isDocumentType** () and **QDomNode::toDocumentType** ().
        """
        ...

    def notations(self) -> PySide2.QtXml.QDomNamedNodeMap:
        """
        **QDomNamedNodeMap QDomDocumentType::notations() const**

        Returns a map of all notations described in the DTD.
        """
        ...

    def publicId(self) -> str:
        """
        **QString QDomDocumentType::publicId() const**

        Returns the public identifier of the external DTD subset or an empty string if there is no public identifier.

        **See also** **systemId** (), **internalSubset** (), and **QDomImplementation::createDocumentType** ().
        """
        ...

    def systemId(self) -> str:
        """
        **QString QDomDocumentType::systemId() const**

        Returns the system identifier of the external DTD subset or an empty string if there is no system identifier.

        **See also** **publicId** (), **internalSubset** (), and **QDomImplementation::createDocumentType** ().
        """
        ...
