"""
PySide2 stub files generated by **IceSpringPySideStubs**

Home page: https://github.com/baijifeilong/IceSpringPySideStubs

Generated by BaiJiFeiLong@gmail.com

Licence: GPL-3
"""
import typing
import PySide2
import PySide2.QtCore
import PySide2.QtXml

bytes = str


class QDomEntity(PySide2.QtXml.QDomNode):
    """
    **Detailed Description**

    This class represents an entity in an XML document, either parsed or unparsed. Note that this models the entity itself not the entity declaration.

    DOM does not support editing entity nodes; if a user wants to make changes to the contents of an entity, every related **QDomEntityReference**  node must be replaced in the DOM tree by a clone of the entity's contents, and then the desired changes must be made to each of the clones instead. All the descendants of an entity node are read-only.

    An entity node does not have any parent.

    You can access the entity's **publicId** (), **systemId** () and **notationName** () when available.

    For further information about the Document Object Model see **Level 1**  and **Level 2 Core** . For a more general introduction of the DOM implementation see the **QDomDocument**  documentation.
    """

    @typing.overload
    def __init__(self) -> None:
        """
        **QDomEntity::QDomEntity()**

        Constructs an empty entity.
        """
        ...

    @typing.overload
    def __init__(self, x: PySide2.QtXml.QDomEntity) -> None:
        """
        **QDomEntity::QDomEntity()**

        Constructs an empty entity.
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    def nodeType(self) -> PySide2.QtXml.QDomNode.NodeType:
        """
        **QDomNode::NodeType QDomEntity::nodeType() const**

        Returns `EntityNode`.
        """
        ...

    def notationName(self) -> str:
        """
        **QString QDomEntity::notationName() const**

        For unparsed entities this function returns the name of the notation for the entity. For parsed entities this function returns an empty string.
        """
        ...

    def publicId(self) -> str:
        """
        **QString QDomEntity::publicId() const**

        Returns the public identifier associated with this entity. If the public identifier was not specified an empty string is returned.
        """
        ...

    def systemId(self) -> str:
        """
        **QString QDomEntity::systemId() const**

        Returns the system identifier associated with this entity. If the system identifier was not specified an empty string is returned.
        """
        ...
